#ifndef _TRANSFERSTRUCTS_H__
#define _TRANSFERSTRUCTS_H__


#define cNUM_OF_FUNCTIONS 3
#define cNUM_OF_PAYMENT_TYPES 2
#define cNUM_OF_CURRENCY_TYPES 2

// same value as in dtcFunctions
//
#define cIXPROJECT		50
#define cIXCONTACTS		1
#define cIXFAVORITES	2
#define cIXFTP			3

// Same value as in dtcItemType
//
#define cITMASTERPROJECT	1
#define cITSUB_PROJECT		2
#define cITFUNCTION			3
#define cITFOLDER			4
#define cITFILE				5


// Data about the user account 
//
struct sNewUser
{
public:
	// General
	CString	m_userName;
	CString	m_password;
	CString	m_confirmPassword;
	CString	m_company;
	CString	m_fullName;
	CString	m_address;
	CString	m_zipCode;
	CString	m_phone;
	CString	m_fax;
	CString	m_country;
	CString	m_city;
	CString m_email;

	// Functions
	BOOL	m_functions[cNUM_OF_FUNCTIONS];	
	int		m_storage;
	int		m_currencyType;
	int		m_paymentType;
	int		m_price;

	// dtMasterProject
	UINT	m_MProjectID;		// MProjectID in dtMasterProject


	// Security
	//CString	m_chgPassEveryXDay;
	//CString	m_lockoutAfterXBadLogins;
	//CString	m_resetCounterAfterXMinutes;
	//CString	m_locoutDuration;
};

// Used to transfer data to and from cccdRegUsr.... dialogs to the ccServer
//
struct sRegUsr
{
	sRegUsr()
	{
		// Function data initialization
		m_numOfFunctions = cNUM_OF_FUNCTIONS;
		
		m_functionName [cIXCONTACTS-1].LoadString( IDS_F_CONTACTS );
		m_functionPrice[cIXCONTACTS-1]= 10;
		m_autoChecked  [cIXCONTACTS-1] = 1;
		m_enabled	   [cIXCONTACTS-1] = 0;

		m_functionName [cIXFAVORITES-1].LoadString( IDS_F_FAVORITES );
		m_functionPrice[cIXFAVORITES-1]= 20;
		m_autoChecked  [cIXFAVORITES-1] = 1;
		m_enabled	   [cIXFAVORITES-1] = 1;

		m_functionName [cIXFTP-1].LoadString( IDS_F_FTP );
		m_functionPrice[cIXFTP-1]= 30;
		m_autoChecked  [cIXFTP-1] = 1;
		m_enabled	   [cIXFTP-1] = 1;

		// Storage initialization
		m_freeStorage = 5;
		m_storagePrice = 10;

		// Paymenttypes initialization
		m_numOfPaymentTypes = cNUM_OF_PAYMENT_TYPES;		
		m_paymentTypeName[0].LoadString( IDS_PT_POSTFORSKOTT );
		m_paymentTypeName[1].LoadString( IDS_INVOICE );
		
		// Currency types initialization
		m_numOfCurrencyTypes = cNUM_OF_CURRENCY_TYPES;
		m_currencyTypeName[0].LoadString( IDS_CT_SVENSKA_ENKRONOR ); 
		m_currencyTypeName[1].LoadString( IDS_CT_US_DOLLAR );

		//
		initNewUser();
	}
	void initNewUser()
	{
		#ifdef _DEBUG
			m_newUser.m_userName		= "CyberCow";
			m_newUser.m_password		= "ferdnand";
			m_newUser.m_confirmPassword	= "ferdnand";
			m_newUser.m_company			= "CyberCow AB";
			m_newUser.m_fullName		= "Daniel E Lindh";
			m_newUser.m_address			= "Atterbomsv. 60 5tr";
			m_newUser.m_zipCode			= "112 57";
			m_newUser.m_city			= "STOCKHOLM";
			m_newUser.m_country			= "Sweden";
			m_newUser.m_phone			= "08-555 362 95";											
			m_newUser.m_email			= "daniel.lindh@home.se";											
		#endif
			
		for (int i=0; i < m_numOfFunctions; i++)
		{
			m_newUser.m_functions[i] = m_autoChecked[i];
		}
		
		m_newUser.m_storage			= m_freeStorage;
		m_newUser.m_currencyType	= 0;
		m_newUser.m_paymentType		= 0;
		m_newUser.m_price			= 0;

		m_newUser.m_MProjectID = 0;

	}
public:
	// *** User account information
	sNewUser m_newUser;

	// *** Function data
	int m_numOfFunctions;

	CString m_functionName[cNUM_OF_FUNCTIONS];			// The name of the function
	int		m_functionPrice[cNUM_OF_FUNCTIONS];			// The price in Svenska Enkronor for the function.
	BOOL	m_autoChecked[cNUM_OF_FUNCTIONS];			// Auto select the function for the user
	BOOL	m_enabled[cNUM_OF_FUNCTIONS];				// The user must or can't have the function, the developer decides.

	// *** Storage
	int m_freeStorage;									// How many megabytes the user gets for free.
	int m_storagePrice;									// The price in Svenska Enkronor one megabyte costs.

	// *** Payment types
	int m_numOfPaymentTypes;

	CString m_paymentTypeName[cNUM_OF_PAYMENT_TYPES];

	// *** Currency types
	int m_numOfCurrencyTypes;

	CString m_currencyTypeName[cNUM_OF_CURRENCY_TYPES];

};


// *** Used when loading information to the FolderListView

// FolderListView TreeOrderSubItems
//
// If the struct is a MasterProject nParentID and nItemID is -1.
// 
struct sFLVTreeOrderSubItems
{	
	// Primkey
	int		 nMProjectID;
	int		 nParentID;		// dtTreeOrder.ItemID
	int		 nItemID;		// dtTreeOrder.ChildID							

	ccString strName;
	int      nItemType;
	int      nFunctionType;	
	bool	 bExpanded;
};

// *** Used when retriving records from the Contacts Function tables.

// 
//
//
struct sTFContacts
{	
	long	nItemID;
	CString strDisplay;
	CString strPrimMail;
	CString strBussinessPhone;
	CString strHomePhone;
};

#endif //_TRANSFERSTRUCTS_H__

