// ==========================================================================
//                    Class Specification : ccDataDictionary
// ==========================================================================
//////////////////////////////////////////////////////////////////////
// $File name   : /ccLib/dev/ccdbLib/ccDataDictionary.h: 
//
// $Author      : Daniel Lindh (Daniel.Lindh@home.se)
// $HomePage    : home.bip.net/CyberCow
// $ICQ         : 7983755
//
// Notice       : Copyright (c) CyberCow AB 2000
//                Ekbacksvgen 60
//                168 69 BROMMA
//                SWEDEN  
//                tel int + 46 (8) 555 362 95
//                
//                The copyright to the computer program(s) herein is the 
//				  property of CyberCow.The program(s) may be used and/or 
//				  copied only with the written permission of CyberCow or 
//				  in accordance with the terms and conditions stipulated 
//				  in the agreement/contract under which the program(s) 
//				  have been supplied. 
//
/////////////////////////////////////////////////////////////////////////////
///** $History$ *************************************************************
// *
// * $Date: 4/27/2000 11:17 $
// * $Revision: 2 $
// * 
// * *****************  Version 1  *****************
// * User: Daniel Date: 9/13/99 14:54
// * Source-Code Traced [ ]; Reviewd [ ] 
// * Created in $/ccLib/dev/ccdbLib
// * Initial release.
// * *****************  Version 2  *****************
// * User: Daniel Date: 4/27/2000 11:17
// * Source-Code Traced [ ]; Reviewd [ ] 
// * Created in $/ccLib/dev/ccdbLib
// * Start Adding ADO
// * 
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
// ** $Properties$ **********************************************************
// * [X] Abstract class (does not have any objects)
// * [X] Uses exceptions
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
/*
$Description : 

  This class handles all the communications with the database tables. 
  You can say that this is the middle tier in a three tier structure. All
  bussniess logic is placed in this class.

*/
/////////////////////////////////////////////////////////////////////////////
#ifndef __CCDATADICTIONARY_H__
#define __CCDATADICTIONARY_H__


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#define CATCH_ADOR( apRec ) \
    catch(_com_error &e)\
    {\
        _variant_t vtConnect = apRec->GetActiveConnection();\
        switch(vtConnect.vt)\
        {\
            case VT_BSTR:\
                ccThrowccException( getComError(e) );\
            case VT_DISPATCH:\
                ccThrowccException( getProviderError( vtConnect) );\
            default:\
                ccThrowccException("Recordset error occured.");\
        }\
	}
    
// Classes used.
//
class ccField;
class ccDataBase;
class ccdbSuperCtrl;
class ccNonDBCtrl;

// Events who will be executed by the ccdbSuperCtrl
//
enum CCDD_FIELD_EVENT
{
	CCDD_INVALID = 0,
	CCDD_ONSETFOCUS,
	CCDD_ONKILLFOCUS,
	CCDD_ONVALIDATE,
	CCDD_ONPOPUP,
	CCDD_ONENDPOPUP,
	CCDD_HASPOPUP,
	CCDD_ONCHANGE
};

// DataDictionary End_Popup info
//
typedef struct tagDDEP_DISPINFO 
{ 
    CString	m_itemText;			// The text on the selected item.
	int		m_itemNum;			// The item number on the selected item.
} DDEP_DISPINFO;

// Used by OnFieldEvent
//
typedef struct tagDD_DISPINFO 
{ 
	tagDD_DISPINFO() : m_endPopupInfo(NULL), m_field(NULL), m_superCtrl(NULL)   {};

	DDEP_DISPINFO	* m_endPopupInfo;				//Send from listPopupDialog to OnFieldEvent(CCDD_ONENDPOPUP,.......)
	ccField			* m_field;
	ccdbSuperCtrl	* m_superCtrl;
} DD_DISPINFO;

// This must be called from all ccDataDictionary dervied classes. The
// macro should be called from the header. 
// This to provied support for ccField events.
//
#define DECLARE_CCFIELD_EVENT() virtual bool OnFieldEvent(CCDD_FIELD_EVENT aEvent, DD_DISPINFO * aDispInfo);

// This must be called from all ccDataDictionary dervied classes. The
// macro should be called from the cpp file. 
// This to provied support for ccField events.
//
// The case statement 65536 is only there to eleminate the compiler warning, 
// that tells us that we need atleast one case statement.
//
#define BEGIN_CCFIELD_EVENT( aParentClass )  \
	bool aParentClass::OnFieldEvent(CCDD_FIELD_EVENT aEvent, DD_DISPINFO * aDispInfo) 	\
	{																																\
		if ( aDispInfo->m_field == NULL)																							\
			return CCFAILED;																										\
																																	\
		switch ( aDispInfo->m_field->getFieldID() )																					\
		{																															\
		case 65536: ccErr( IDS_INVALID_CONTROL_ID ); return CCFAILED;


// This is the end "brace" for the BEGIN_CCFIELD_EVENT. 
//
#define END_CCFIELD_EVENT()										\
		default:												\
			switch (aEvent)										\
			{													\
			case CCDD_ONSETFOCUS:			return CCSUCCEDED;	\
			case CCDD_ONKILLFOCUS:			return CCSUCCEDED;	\
			case CCDD_ONVALIDATE:			return CCSUCCEDED;	\
			case CCDD_ONPOPUP:				return CCSUCCEDED;	\
			case CCDD_ONENDPOPUP:			return CCSUCCEDED;  \
			case CCDD_HASPOPUP:				return false     ;	\
			case CCDD_ONCHANGE:				return CCSUCCEDED;	\
			default:						return CCFAILED  ;	\
			}													\
		}														\
		return CCFAILED;										\
	}


// This is the "case" statement for the BEGIN_CCFIELD_EVENT.
//
#define ON_CCFIELD( aID, aOnSetFocus, aOnKillFocus, aOnValidate, aOnPopUp, aOnEndPopup, aOnChange)	\
		case aID:																					\
			switch (aEvent)																			\
			{																						\
			case CCDD_ONSETFOCUS:			return aOnSetFocus( aDispInfo );	  					\
			case CCDD_ONKILLFOCUS:			return aOnKillFocus( aDispInfo ); 						\
			case CCDD_ONVALIDATE:			return aOnValidate( aDispInfo );  						\
			case CCDD_ONPOPUP:				return aOnPopUp( aDispInfo );	  						\
			case CCDD_ONENDPOPUP:			return aOnEndPopup( aDispInfo );						\
			case CCDD_HASPOPUP:				if (aOnPopUp == NoFunc) return false; else return true; \
			case CCDD_ONCHANGE:				return aOnChange( aDispInfo );		  					\
			default:						return CCFAILED;										\
			}


class AFX_EXT_CLASS ccDataDictionary 
{
// *** Friends classes
	friend class ccdbSuperCtrl;

// *** Construction / Destruction
public:
	// Default Constructor
	//
	ccDataDictionary(ccDataBase * pDataBase);

	// Open the recordset throw ADO
	//
	void openADO(LPCSTR aSQLQuery, enum ADODB::CursorTypeEnum aCursorType  = ADODB::adOpenDynamic ,
		 	     enum ADODB::LockTypeEnum aLockType  = ADODB::adLockPessimistic ,
			     enum ADODB::CursorLocationEnum aCursorLocation  = ADODB::adUseClient );

	// Close the connection to the database
	//
	void close();

	// Default Destructor
	//
	~ccDataDictionary();

	// Bind a Ctrl to the dataDictionary how will get
	// refresh, save, delete etc messages..	
	//
	void bindNonDBCtrls( ccNonDBCtrl * ctrl);
	bool removeNonDBCtrls( ccNonDBCtrl * ctrl );
protected:
	// Add table fields to use from the database table. 
	// Usually called by the ccField::bind
	//	
	void bind( ccField& aoField, UINT nID, LPCSTR asColumnName );

	// Rebind the ccField to the recordset fields.
	//
	void reBindAll();

	// If some dataDictionary has a relation to this dd, the child field 
	// will be related to the primKey field. This field must also be sorted
	//
	void setPrimKey( ccField * aoPrimKey);
	ccField * getPrimKey()								{ return m_primKey;					};

	/*
	// Tell in which order the rows should be sorted.
	// The table must be opened.
	//
	void sortBy( ccField * aoSortField ...  );*/


// *** Attribute
public:
	// Return the database this object is connected to.
	//
	void setDB( ccDataBase* aDB )					{ m_DB = aDB;							};
	ccDataBase* __getDB()							{ return m_DB;							};

	// Get a pointer to the recordset object.
	//
	ADODB::_RecordsetPtr getRS()					{ return m_recordset;					};

	// Tell if the table has been opened.
	//
	BOOL isOpen();

	// Check if the current opened Recordset supports all used ado members.
	//
	bool isSupporting();

	//  Supports the Update method to modify existing data???
	//
	bool canUpdate()								{ return m_recordset->Supports(ADODB::adUpdate) ==0 ?false:true ;		};

	// Indicates that the current record has been deleted.
	//
	bool isDeleted()								{ return m_recordset->EditMode == ADODB::adEditDelete;	};

	bool isCathingNativeError(int nNativeError);

	//
	//
	void setModified(bool bModified)				{ m_modified = bModified;								};

	// True if the record has been modified since last save
	// 	
	bool isModified();

	//
	//
	bool isEOF()									{ return m_recordset->adoEOF ? true : false;			};

	//
	//
	bool isBOF()									{ return m_recordset->BOF ? true : false;				};

	//
	//
	bool isEmpty()									{ return (isEOF() && isBOF());							};

	//
	// 
	void filter( LPCSTR strFilter);


private:
	// Handling the database type
	//
	void setDataBaseType( CCDB_DATABASETYPE aType )	{ m_dataBaseType = aType;				};
	CCDB_DATABASETYPE getDataBaseType()				{ return m_dataBaseType;				};	

// *** Confirmation 
public:
	// Showing the confirmation messages when saveRecord 
	// deleteRecord etc.
	//
	BOOL showConfirmMsg( CString asMessage );

	// The Confirmation message who should be shown when saveing record.
	// if the asMessage string is empty no message will be shown.
	// if the aiResource is 0 no message will be shown.
	//		
	void setConfirmSaveMsg( int aiResource );		
	void setConfirmSaveMsg( CString asMessage )		{ m_confirmSaveMsg = asMessage;						}
	CString getConfirmSaveMsg( )					{ return m_confirmSaveMsg;							}

	// The Confirmation message who should be shown when deleteing record.
	// if the asMessage string is empty no message will be shown.
	// if the aiResource is 0 no message will be shown.
	//		
	void setConfirmDeleteMsg( int aiResource );		
	void setConfirmDeleteMsg( CString asMessage )	{ m_confirmDeleteMsg = asMessage;					}
	CString getConfirmDeleteMsg( )					{ return m_confirmDeleteMsg;						}

	// The Confirmation message who should be shown when clearing record.
	// if the asMessage string is empty no message will be shown.
	// if the aiResource is 0 no message will be shown.
	//		
	void setConfirmClearMsg( int aiResource );		
	void setConfirmClearMsg( CString asMessage )	{ m_confirmClearMsg = asMessage;					}
	CString getConfirmClearMsg( )					{ return m_confirmClearMsg;							}


// *** General
private:
	// Calling the refresh member in all attached ccFields.
	// Which usally means updating the contents in the
	// ccdbSuperCtrls attached to the ccFields.
	//
	virtual E_ccErrRet refresh();

	// Same as refresh but will also be applyed to 
	// all parents
	//
	virtual E_ccErrRet refreshRelations();

// *** Navigation
public:
	// Move current record pointer to the first record in the table
	//
	E_ccErrRet moveFirst();

	// Move current record pointer to the previous record in the table
	//
	E_ccErrRet movePrev();

	// Move current record pointer to the next record in the table
	//
	E_ccErrRet moveNext();

	// Move current record pointer to the last record in the table
	//
	E_ccErrRet moveLast();

	// Jump to the specifed bookmark in the table.
	//
	//E_ccErrRet setBookmark( const CDBVariant& varBookmark );

	//
	//
	E_ccErrRet find(LPCSTR strCriteria);


// *** Update the database
public:
	// Get the latest information from the database fields 
	// to the datadictionary fields.
	//
	E_ccErrRet requery();

	// Save information in the datadictionary fields to the database
	// and clear all the fields.
	//
	E_ccErrRet saveRecord();

	// Save information in the datadictionary fields to the database	
	//
	E_ccErrRet saveRecordNoClear();

	// Delete the record the current record pointer is pointing to.
	//
	E_ccErrRet deleteRecord();

	// Clear all the fields in the datadictionary.
	//
	E_ccErrRet clearRecord(bool bDontShowConfirmMsg = false);

	// Find the record with the index typed in the indexed ctrls.
	//
	E_ccErrRet findRecord( ccField * aField);

// *** Relations
public:
	// Make a relationship between two tables.
	// Their can only be one relationship between two tables.
	//
	void relate( ccField & aChild, ccField & aParent);

private:
	// Add a child to this parent. 
	// The list is used by deleteRecord.
	// OBS Only used from ccDataDictionary::relate
	//
	void addChildDDField( ccField & aChildField, ccField & aParentField  );

	// Find all parents to this dd.
	//
	void relateFind();

	// Not supported yet.
	//
	void relateDelete( ccField * aColumn, ccField * aValue );

	// Check this and all parents dd if they can be cleared.
	//
	BOOL relateCanClear();

	// Clear this and all parent dd:s.
	//
	E_ccErrRet relateClear();

	// Save this and all parent dd:s to the database.
	//
	E_ccErrRet relateSave();

	// Prepare this and all parent dd:s for a save.
	//
	void relatePrepareSave();

	// Check this and all parent dd:s if they can be saved.
	//
	BOOL relateCanSave();

	// Check if this or any parent dd has been modified.
	//
	BOOL relateIsModified();

	// Call the backout procedure for this and all parents, starting
	// with the top parents.
	//
	void relateBackout();

	// Call the creating procedure for this and all parents, starting
	// with the top parents.
	void relateCreating();

	// Call the updating procedure for this and all parents, starting
	// with the this datadictionary
	void relateUpdateing();


// *** Status
private:		
	// True if the record in the buffer is a new record. 
	// Which means that it doesn't exist in the database.
	//
	inline void setNewRecord( bool abNewRecord )	{ m_newRecord = abNewRecord;						}
	inline bool isNewRecord() const					{ return m_newRecord;								}	

	// Call this after "AddNew" and "Edit" so the saveRecord 
	// know that it can save the record.
	//
	inline void enableCanSave( bool abEnable)		{ m_bcanSave = abEnable;							}
 	inline bool canSave() const						{ return m_bcanSave;								}

// *** Events ** Is not used directley by user **
public:		
	// Handling events on the attached ccFields attached ccdbSuperCtrl:s	
	//
	virtual bool OnFieldEvent(CCDD_FIELD_EVENT aEvent, DD_DISPINFO * aDispInfo ) = 0;

	// Used by the BEGIN_CCFIELD_EVENT, ON_CCFIELD  and
	// END_CCFIELD_EVENT macros.
	// And it should only return CCSUCCEDED.
	bool NoFunc( DD_DISPINFO * aDispInfo )			{ return CCSUCCEDED;			};

// ** Events
protected:		
	// This function is called before a new record is created.
	// Which means absolutely before the record is saved in 
	// the database table.
	//
	virtual void creating()							{								};

	// This function is called before a record is deleted..
	// Which means absolutely before the record is deleted
	// from the database table.
	//
	virtual void deleting()							{								};

	// This function is called before the deleteing is called.
	// and when updating an old record, before the updating.
	//
	// Caution: Should have the old value, but have the new!!!!
	//
	virtual void backout()							{								};

	// This function is called when a new record is called, 
	// after the creating has been called.
	// It is also called when an old record is called, just
	// after the backout has been called and before the
	// record has been updateed in the database table.
	//
	virtual void updateing()						{								};

	// This function is called after a succefull
	// moveNext, prev, first, last.....
	//
	virtual void OnFieldChangeComplete()			{								};

	// This function is called after a succefully
	// clearRecord..
	//
	virtual void OnFieldClearComplete()				{								};

// *** DataMembers
private:
	ccDataBase* m_DB;

	CCDB_DATABASETYPE m_dataBaseType;	

	CPtrArray m_fields;					// see bind.
	CPtrArray m_nonDBBoundCtrls;		// see bindNonDBCtrls
	ADODB::_RecordsetPtr m_recordset;	// see getRS;	

	bool m_newRecord;			// see setNewRecord

	bool m_bcanSave;			// see enableCanSave

	bool m_modified;			// see setModified

	// Relations
	ccField * m_primKey;				// see m_primKey	

	CPtrArray m_childField;			// See relate
	CPtrArray m_parentField;		// See relate

	CPtrArray m_childDDSChildField;		// See addChildDDField
	CPtrArray m_childDDSParentField;	// See addChildDDField

	// Confirmation 
	CString m_confirmSaveMsg;	// see setConfirmSaveMsg
	CString m_confirmDeleteMsg;	// see setConfirmDeleteMsg
	CString m_confirmClearMsg;	// see setConfirmClearMsg

	enum ADODB::CursorTypeEnum m_cursorType;
/*
// *** Constrain
public:
	// Clear the constrain string.
	//
	void clearConstrain();

	// Constrain to an integer.
	//
	void addConstrain( ccField *aoConstrainField, CString aCompOp, int aiConstrainValue);
	
	// Constrain to a string.
	//
	void addConstrain( ccField * aoConstrainField, CString aCompOp, CString asConstrainValue);

	// Apply the constrain string to the table and refilter it.
	//
	E_ccErrRet executeConstrain();

	// Manual Constrain.
	//
	E_ccErrRet filterBy(CString asFilter);
private:		
	CString m_constrainFilter;			// The constrian filter string.
	
*/
};

#endif // __CCDATADICTIONARY_H__
