// ==========================================================================
//                    Class Specification : ccField
// ==========================================================================
//////////////////////////////////////////////////////////////////////
// $File name   : /ccLib/dev/ccdbLib/ccField.h: 
//
// $Author      : Daniel Lindh (Daniel.Lindh@home.se)
// $HomePage    : home.bip.net/CyberCow
// $ICQ         : 7983755
//
// Notice       : Copyright (c) CyberCow 1999
//                Knypplerskevagen 24
//                168 38 BROMMA
//                SWEDEN  
//                tel int + 46 (8) 26 45 95
//                
//                The copyright to the computer program(s) herein is the 
//				  property of CyberCow.The program(s) may be used and/or 
//				  copied only with the written permission of CyberCow or 
//				  in accordance with the terms and conditions stipulated 
//				  in the agreement/contract under which the program(s) 
//				  have been supplied. 
//
/////////////////////////////////////////////////////////////////////////////
///** $History$ *************************************************************
// *
// * $Date: 9/03/99 10:17 $
// * $Revision: 1 $
// * 
// * *****************  Version 1  *****************
// * User: Daniel Date: 9/13/99 14:54
// * Source-Code Traced [ ]; Reviewd [ ] 
// * Created in $/ccLib/dev/ccdbLib
// * Initial release.
// * 
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
// ** $Properties$ **********************************************************
// * [ ] Abstract class (does not have any objects)
// * [ ] Uses exceptions
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
/*
$Description : 


*/
/////////////////////////////////////////////////////////////////////////////
#ifndef __CCFIELD_H__
#define __CCFIELD_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Diffrent types of ctrls the connected 
// ccdbSuperCtrl can handle.
//
enum E_CCSC
{
	CCSC_INVALID = 0,
	CCSC_EDIT,
	CCSC_COMBO,		
	CCSC_CHECKBOX,
	CCSC_PICTURE
};

// Flags used by the setOptions
//
#define DD_AUTOBACK                0x0001  // Not Implemented
#define DD_AUTOFIND                0x0002  // Not Implemented
#define DD_AUTOFIND_GE             0x0004  // Not Implemented
#define DD_AUTORETURN              0x0010  // Not Implemented
#define DD_CAPSLOCK                0x0020  // Not Implemented
#define DD_DISPLAYONLY             0x0040  // Not Implemented
#define DD_FINDREQ                 0x0080  // Not Implemented
#define DD_FORCEPUT                0x0100  // Not Implemented
#define DD_NOENTER                 0x0200  // Not Implemented
#define DD_NOPUT                   0x0400  // Not Implemented
#define DD_REQUIRED                0x0800  // Not Implemented
#define DD_RETAIN                  0x1000  // Not Implemented
#define DD_RETAIN_ALL              0x2000  // Not Implemented
#define DD_SKIPFOUND               0x4000  // Not Implemented
#define DD_ZERO_SUPPRESS           0x8000  // Not Implemented

// Classes used.
//
#include "ccDataDictionary.h"
class ccdbCtrl;
class ccdbSuperCtrl;

class AFX_EXT_CLASS ccField : public CObject
{
// *** Construction/Destruction
public:		
	// Default Constructor
	//
	ccField();
		
	// Bind the ccField object to a field in the ccDataDictionary recordset
	//
	void bind( ccDataDictionary * aoDD, UINT nID, LPCSTR asColumnName, ADODB::Field * aADOField );

	// Default Destructor
	//
	~ccField();

//private: Friend
	// Handling the list of attached ccdbSuperctrls.
	//
	BOOL addAttachedCtrl( ccdbCtrl * aodbCtrl );
	BOOL removeAttachedCtrl( ccdbCtrl * aodbCtrl );


// *** Attributes
public:
	// Get a pointer to the database this fields datadictionary
	// is connected too.
	//
	ccDataBase       * __getDB()					{ return m_oDD->__getDB();				};

	// Get a pointer to the dataditonary this field is connected too.
	// 
	ccDataDictionary * getDD()						{ return m_oDD;							};

	// Set/Get the Field from the recordset field collection
	// 
	void setADOField( ADODB::Field * aADOField )	{ m_adoField = aADOField;				};
	ADODB::Field * getADOField();					

	// //TODO is this right
	//
	CString getADOFieldValue();

	// Handling the id number on the field, used by OnSetFocus etc...
	//
	void	setFieldID( UINT anID )					{ m_nID = anID;							};
	UINT	getFieldID( )          					{ return m_nID;							};

	// The name of the database table column this ccField 
	// should be connected too.
	//
	void	setColumnName( LPCSTR asColumnName )	{ m_columnName = asColumnName;			};
	CString	getColumnName()							{ return m_columnName;					};

// *** Attributes of the table field, and the connected ccdbSuperCtrl
public:
	// Tell the attached ctrl:s that this column is sorted.
	// So the acclerator keys F7 and F8 etc works..
	//
	void enableColumnSorting( BOOL abEnabled )		{ m_columnSorted = abEnabled;			};
	BOOL isColumnSorted( )							{ return m_columnSorted;				};

	// The type of the database table field. ( adBoolean, adVarChar etc.)
	// 
	void initFieldType( );
	ADODB::DataTypeEnum	getFieldType()				{ return getADOField()->Type;			};	

	// The Precsion of the database table field. 
	//
	//void	setFieldPrecision( UDWORD aPrecision )	{ m_fieldPrecision = aPrecision;		};
	BYTE	getFieldPrecision()						{ return getADOField()->Precision;		};

	// The Scale of the database table field. 
	//
	//void	setFieldScale( SWORD aScale )			{ m_fieldScale = aScale;				};
	BYTE	getFieldScale()							{ return getADOField()->NumericScale; 	};

	// This property is used to set the field properties of a field. 
	//
	void  modifyOptions( DWORD aRemove, DWORD aAdd);
	void  setOptions( DWORD aAdd)					{ modifyOptions( 0, aAdd);				};	
	DWORD getOptions()								{ return m_options;						};

	// The text that will be shown in the status bar when
	// this object takes focus.
	//
	void	setStatusHelp( CString asHelp )			{ m_statusHelp = asHelp;				};
	CString getStatusHelp( )						{ return m_statusHelp;					};

// *** 	Attributes for the connected ccdbSuperCtrl
public:
	// A long description of the name of attached 
	// ctrls for such purposes as form captions.
	//
	void	setLongCaption( LPCSTR asCaption ) 		{ m_longCaption = asCaption;			};
	CString	getLongCaption()						{ return m_longCaption;					};
	
	// A short description of the name of attached ctrls 
	// for such purposes as grid column headings. 
	//
	void	setShortCaption( LPCSTR asCaption )		{ m_shortCaption = asCaption;			};
	CString	getShortCaption()						{ return m_shortCaption;				};

	// The ctrl type this field will be presented with.
	//
	void	setCtrlType( E_CCSC aCtrlType );
	E_CCSC  getCtrlType()							{ return m_ctrlType;					};

	// The style on the connected ccdbSuperCtrl.
	//
	void 	setStyle( DWORD adwStyle )				{ m_Style = adwStyle ;					};
	DWORD	getStyle()								{ return m_Style;						};	

	// The exStyle on the connected ccdbSuperCtrl.
	//
	void 	setexStyle( DWORD adwexStyle )			{ m_exStyle = adwexStyle ;				};
	DWORD	getexStyle()							{ return m_exStyle;						};

	// Enables or disables mouse and keyboard input. 
	//
	void enableWindow( BOOL bEnable = TRUE ); 

	// Set the edit ctrl to be multilined.
	//
	void setEditMultiLine( BOOL abEnable = true);

	//
	//
	void setFieldValueCheck(CString aCheck)			{;										};
	
	//
	//
	void setFieldValueRange(int aMin, int aMax)		{;										};

// *** 	Attributes for the connected ccdbSuperCtrl if ctrlType is CCSC_EDIT and CCSC_CHECKBOX
public:
	// The mask type on the edit box, if the developer wants to change from the default.
	// Usually only done when changeing from diffrent date types.
	//
	void	 setMaskType( CCE_TYPE aMask )			{ m_editMask = aMask;					};
	CCE_TYPE getMaskType( )							{ return m_editMask;					};

	// Set a custom mask. Valid masks are '?' any char, '#' only numbers
	// '%' only alpha numeric
	//	
	void setCustomMask( CString asMask, char acPlaceHolder = '_' );
	CString	getCustomMask()							{ return m_customMask;					};
	char    getPlaceHolder()						{ return m_placeHolder;					};

	// Sends a refresh to all attached ccdbSuperCtrl:s
	//
	BOOL refresh( void );	

public: 
	// This should be removed.	
	//CString m_RFXpublicValue;				// This member should only be used by the RFX_Text macro.
											// If you need the value on any other place use the getValue 
											// and setValue functions.
private:
	CPtrArray			m_attachedCtrls;	// See addAttachedCtrl
	
	ADODB::Field * m_adoField;				// see bind and getADOField
	
	_variant_t m_vDataValue;				// This is a cache for the adorecordset->fields->item[]->value

	ccDataDictionary   *m_oDD;				// See getDD
	UINT				m_nID;				// See setFieldID

	// Attributes of the table field, and the connected ccdbSuperCtrl
	CString m_columnName;					// See setColumnName
	BOOL	m_columnSorted;					// See enableColumnSorting	
	DWORD	m_options;						// see setOptions
	CString m_statusHelp;					// see setStatusHelp


	// Attributes for the connected ccdbSuperCtrl
	E_CCSC		m_ctrlType;					// See setCtrlType
	CString		m_longCaption;				// See setLongCaption	
	CString		m_shortCaption;				// See setShortCaption
	DWORD		m_Style;					// See setStyle
	DWORD		m_exStyle;					// See setexStyle													
	CCE_TYPE	m_editMask;					// See setMaskType
	CString		m_customMask;				// See setCustomMask
	char		m_placeHolder;				// See setCustomMask	

// *** Input/Output
public:
	// Set the current value of the field to a CString value.
	//
	void setValue( CString &asValue );
	
	// Set the current value of the field to a int value.
	//
	void setValue( int aiValue );

	// Set the current value of the field to a ccTime value.
	//
	void setValue( ccTime & aTime );

	// Set the current value of the field to the current date and time.
	//
	void setCurrentDate();

	// Return the ccField object value.	
	//
	CString	getValue( BOOL abGetRFXValue = FALSE );	

	// Return the ccField object value.
	//
	operator int();
	operator CString();
	operator = ( int aiValue) { setValue( aiValue );					};
	operator +=( int aiValue) { setValue( operator int() + aiValue );	};
	operator -=( int aiValue) { setValue( operator int() - aiValue );	};

// *** Field events.
public:
	// Called by the attached ctrl:s when the focus is set to that ctrl.
	//
	BOOL OnSetFocus(ccdbSuperCtrl *aoCtrl);

	// Called by the attached ctrl:s when it loses it's focus.
	//
	BOOL OnKillFocus(ccdbSuperCtrl *aoCtrl);

	// Called by the attached ctrl:s when they loses it's focus by 
	// pressing enter or tab. It's also called from the datadictionary 
	// when saveing the current record.
	//
	BOOL OnValidate(ccdbSuperCtrl *aoCtrl);	// Called when enter or tab is pressed.

	// Called by the attached ctrl:s when it's contents is changed.
	//
	BOOL OnChange(ccdbSuperCtrl *aoCtrl);	

	// Called by the attached ctrl:s when F4 or the combo button is
	// pressed.
	//
	BOOL OnPopup(ccdbSuperCtrl *aoCtrl);	// Called when F4 is pressed.

	// Return true if a popup is connected to this field.
	//
	BOOL hasPopup();
};

#endif // __CCFIELD_H__
