// ==========================================================================
//                    Class Specification : ccInplaceSuperCtrl
// ==========================================================================
//////////////////////////////////////////////////////////////////////
// $File name   : /ccLib/dev/ccdbLib/ccInplaceSuperCtrl.h: 
//
// $Author      : Daniel Lindh (Daniel.Lindh@home.se)
// $HomePage    : home.bip.net/CyberCow
// $ICQ         : 7983755
//
// Notice       : Copyright (c) CyberCow 1999
//                Knypplerskevagen 24
//                168 38 BROMMA
//                SWEDEN  
//                tel int + 46 (8) 26 45 95
//                
//                The copyright to the computer program(s) herein is the 
//				  property of CyberCow.The program(s) may be used and/or 
//				  copied only with the written permission of CyberCow or 
//				  in accordance with the terms and conditions stipulated 
//				  in the agreement/contract under which the program(s) 
//				  have been supplied. 
//
/////////////////////////////////////////////////////////////////////////////
///** $History$ *************************************************************
// *
// * $Date: 11/01/99 18:43 $
// * $Revision: 1 $
// * 
// * *****************  Version 1  *****************
// * User: Daniel Date: 11/01/99 18:43
// * Source-Code Traced [ ]; Reviewd [ ] 
// * Created in $/ccLib/dev/ccdbLib
// * Initial release.
// *
// * The code contained in this file is based on the original
// * cInplaceSuperCtrl from http://www.codeguru.com/listview/edit_subitems.shtml
// * 
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
// ** $Properties$ **********************************************************
// * [ ] Abstract class (does not have any objects)
// * [ ] Uses exceptions
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
/*
$Description : 
	ccSuperCtrl used in the grid.   
*/
/////////////////////////////////////////////////////////////////////////////
#ifndef __CCINPLACESUPERCTRL_H__
#define __CCINPLACESUPERCTRL_H__

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define ID_EDIT_DELETE						32810
#define ID_SELECTEDITEM_OPEN_GRID_ITEM		32839
#define ID_SELECTEDITEM_DELETE_GRID_ITEM	32840
 
class AFX_EXT_CLASS ccInplaceSuperCtrl : public ccdbSuperCtrl
{
// *** Construction
public:
	//
	//
    ccInplaceSuperCtrl(CWnd* pParent, CRect& rect, DWORD dwStyle, UINT nID,
                 int nRow, int nColumn, ccField *atableField, UINT nFirstChar);
 
// *** Destruction
public:
	//
	//
	virtual ~ccInplaceSuperCtrl();

// *** Properties
public:
	// Right mouse click menu.
	//
	void setFloatMenuID( int aiFloatMenuID ) { m_floatMenuID = aiFloatMenuID;	}

	// Place the edit ctrl somewhere on the screen
	//
	void setPos(CRect aRect, int aiCol, int aiRow);	

	//
	//
	virtual DWORD getEditexStyle();

private:
	int		m_floatMenuID;	// see setFloatMenuID
	
    int     m_nColumn;		// The column in the ccdbGrid
	int     m_nRow;			// The row in the ccdbGrid

    CString m_sInitText;	// The text in the edit ctrl from the beginning
    UINT    m_nLastChar;	// Last typed char.    		


// *** Generated message map functions
protected:
    //{{AFX_MSG(ccInplaceSuperCtrl)        
    afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);	
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg UINT OnGetDlgCode();	
	//}}AFX_MSG
    DECLARE_MESSAGE_MAP()

// *** Overrides
     // ClassWizard generated virtual function overrides
     //{{AFX_VIRTUAL(ccInplaceSuperCtrl)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

	virtual void endEdit();	
};
 
/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // __CCINPLACESUPERCTRL_H__
