// ==========================================================================
//                    Class Specification : ccListPopupDialog
// ==========================================================================
//////////////////////////////////////////////////////////////////////
// $File name   : /ccLib/dev/ccdbLib/ccListPopupDialog.h: 
//
// $Author      : Daniel Lindh (Daniel.Lindh@home.se)
// $HomePage    : home.bip.net/CyberCow
// $ICQ         : 7983755
//
// Notice       : Copyright (c) CyberCow 1999
//                Knypplerskevagen 24
//                168 38 BROMMA
//                SWEDEN  
//                tel int + 46 (8) 26 45 95
//                
//                The copyright to the computer program(s) herein is the 
//				  property of CyberCow.The program(s) may be used and/or 
//				  copied only with the written permission of CyberCow or 
//				  in accordance with the terms and conditions stipulated 
//				  in the agreement/contract under which the program(s) 
//				  have been supplied. 
//
/////////////////////////////////////////////////////////////////////////////
///** $History$ *************************************************************
// *
// * $Date: 10/14/99 20:07 $
// * $Revision: 1 $
// * 
// * *****************  Version 1  *****************
// * User: Daniel Date: 10/14/99 20:07
// * Source-Code Traced [ ]; Reviewd [ ] 
// * Created in $/ccLib/dev/ccdbLib
// * Initial release.
// * 
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
// ** $Properties$ **********************************************************
// * [ ] Abstract class (does not have any objects)
// * [ ] Uses exceptions
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
/*
$Description : 
	A custom popup list box.

	The object instance of this class should be created in the OnPopup member 
	for	a datadictionry. 

    Caution: The object should be a pointer allocated with new. Because
	else the object will be destroyed when the OnPopup returns, and it shouldn't
	do that. But you don't have to care about the deleting cause the DestroyWindow
	takes care of that.

    Example:      
	bool cddTTimeSheet::OnPopupComment( DD_DISPINFO * aDispInfo )
	{
		ccListPopupDialog * lPopupDialog;
		lPopupDialog = new ccListPopupDialog( aDispInfo->m_superCtrl );	
		lPopupDialog->addItem(0, "The Office");
		lPopupDialog->addItem(1, "The Home");
		lPopupDialog->addItem(2, "The Car");
		lPopupDialog->addItem(3, "Computer Installing");
		lPopupDialog->popup();	
		return false;
	}

*/
/////////////////////////////////////////////////////////////////////////////
#ifndef __CCLISTPOPUPDIALOG_H__
#define __CCLISTPOPUPDIALOG_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ccPopupDialog.h"
#include "resource.h"
class ccdbSuperCtrl;

#define  CCLPD_HEIGHT 100

class AFX_EXT_CLASS ccListPopupDialog : public ccPopupDialog
{
// Construction
public:
	//
	//
	void addItem(int liItem, CString asValue);

	//
	//
	ccListPopupDialog(ccdbSuperCtrl* aSuperCtrl);   // standard constructor

	//
	//
	virtual ~ccListPopupDialog() {;};

// Dialog Data
	//{{AFX_DATA(ccListPopupDialog)
	enum { IDD = IDD_LIST_POPUP_DIALOG };
	CListCtrl	m_list;
	//}}AFX_DATA

private:
	CUIntArray		m_itemValue;
	CStringArray	m_itemText;

	bool m_bItemSelected;											

	ccdbSuperCtrl * m_superCtrl;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(ccListPopupDialog)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	virtual void OnOK( );
	virtual void OnCancel( );

public:
	virtual void popup();
	virtual CString getItem(int liItem);

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(ccListPopupDialog)
	virtual BOOL OnInitDialog();
	afx_msg void OnSize(UINT nType, int cx, int cy);	
	afx_msg void OnKillfocusPopupDialogList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclkPopupDialogList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemchangedPopupDialogList(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // __CCLISTPOPUPDIALOG_H__
