//////////////////////////////////////////////////////////////////////
// $File name   : ccdbGrid.cpp
//
// $Author      : Daniel Lindh (Daniel.Lindh@home.se)
// Notice       : Copyright (c) CyberCow 1999
//
//////////////////////////////////////////////////////////////////////

// ccdbGrid.cpp : implementation file
//
// TODO
// Prio 1 = Must have, won't work wihout it.
// Prio 2 = Feature level 1
// Prio 3 = Feature level 2
// Prio 4 = Feature level 3
// Prio 5 = Feature level 4
// Prio
// 3			ScrollBar
// 4			Resizable columns		
// 2			Page Up, page down, end.
//
//
//
// Buggar
// om man ndrar en cell och sedan musclickar en annan rad s ritas inte bakgrunden om..

#include "stdafx.h"
#include "ccdatabase.h"
#include "ccdbSuperCtrl.h"
#include "ccInplaceSuperCtrl.h"
#include "resource.h"

#include "ccdbGrid.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif<

IMPLEMENT_DYNCREATE(ccdbGrid, CWnd)


void AFXAPI DDX_GridControl(CDataExchange* pDX, int nIDC, ccdbGrid& rControl)
{
    if (rControl.GetSafeHwnd() == NULL)    // not subclassed yet
    {
        ASSERT(!pDX->m_bSaveAndValidate);

        HWND hWndCtrl = pDX->PrepareCtrl(nIDC);

        if (!rControl.SubclassWindow(hWndCtrl))
        {
            ASSERT(FALSE);      // possibly trying to subclass twice?
            AfxThrowNotSupportedException();
        }
#ifndef _AFX_NO_OCC_SUPPORT
        else
        {
            // If the control has reparented itself (e.g., invisible control),
            // make sure that the CWnd gets properly wired to its control site.
            if (pDX->m_pDlgWnd->GetSafeHwnd() != ::GetParent(rControl.GetSafeHwnd()))
                rControl.AttachControlSite(pDX->m_pDlgWnd);
        }
#endif //!_AFX_NO_OCC_SUPPORT

    }
}


/////////////////////////////////////////////////////////////////////////////
// *** Construction
/////////////////////////////////////////////////////////////////////////////

ccdbGrid::ccdbGrid()
: m_idCurrentCell(-1,-1)
{
	RegisterWindowClass();
	
	enableInputTopRow( FALSE );	
	setVisibleGridRows( 0 );
	m_bDoubleBuffer		   = TRUE;		// Use double buffering to avoid flicker?
	m_selectedItemMenuID   = -1;		// No menu initialized.
	m_unselectedItemMenuID = -1;

	//Set the fonts
    LOGFONT lf;
    GetObject(GetStockObject(DEFAULT_GUI_FONT), sizeof(LOGFONT), &lf);
	lf.lfWidth = 7;
	m_gridFont.CreateFontIndirect( &lf );
			
	// Set the grid colors
    setLabelRowBkColor(   ::GetSysColor( COLOR_3DFACE ) );
	setLabelRowTextColor( ::GetSysColor( COLOR_WINDOWTEXT) );

	setCellRowBkColor(   ::GetSysColor( COLOR_INFOBK ) );  //COLOR_WINDOW
	setCellRowTextColor( ::GetSysColor( COLOR_INFOTEXT) );//COLOR_WINDOWTEXT

    setInputRowColor(  ::GetSysColor( COLOR_WINDOW ) );

    setBkColor( ::GetSysColor(COLOR_3DSHADOW) );

	setPenColor( ::GetSysColor( COLOR_GRAYTEXT ) );
}

//

BOOL ccdbGrid::SubclassDlgItem(UINT nID, CWnd* pParent)
{	
	BOOL bRet = CWnd::SubclassDlgItem( nID, pParent );

	initCellMargin();

	return bRet;
}	

//

bool ccdbGrid::insertdbField( LPCSTR asHeader, ccField *accField, int aiWidth )
{		
	CString lsHeader = asHeader;
    m_ccFields.Add( accField );

	cGridColumns *lGridLabel;
	lGridLabel = new cGridColumns( lsHeader );	

	if ( aiWidth == -1 )
		lGridLabel->setWidth( getTextWidth( lsHeader ) + m_cellMargin*2 );
	else 
		lGridLabel->setWidth( aiWidth );

	CRect lRect(0,0,0,0);
	DWORD dwStyle = ES_LEFT;	
		
	lGridLabel->m_editCtrl = new ccInplaceSuperCtrl(this, lRect, dwStyle, IDC_INPLACE_CONTROL, 0, 0, accField, VK_LBUTTON);
	lGridLabel->m_editCtrl->setFloatMenuID( m_selectedItemMenuID );		
	
	m_gridColumns.Add( lGridLabel );
	
	return true;	
}

//

void ccdbGrid::fill()
{
	ShowScrollBar( SB_VERT );

	// Get the position and size of the grid.
	GetWindowRect( m_gridClipRect );
	m_gridClipRect.right  -= m_gridClipRect.left;
	m_gridClipRect.bottom -= m_gridClipRect.top;
	m_gridClipRect.top  = 0;
	m_gridClipRect.left = 0;
		
	calcCellPos();

	// Get data from the database to the grid.
	firstRow();

	// TODO
	//	SetScrollRange( SB_VERT, 0, getDD()->GetRecordCount() );
	// 
}

//

BOOL ccdbGrid::RegisterWindowClass()
{
    WNDCLASS wndcls;
    HINSTANCE hInst = AfxGetInstanceHandle();
   // HINSTANCE hInst = AfxGetResourceHandle(); 

    if (!(::GetClassInfo(hInst, GRIDCTRL_CLASSNAME, &wndcls)))
    {
        // otherwise we need to register a new class
        wndcls.style            = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
        wndcls.lpfnWndProc      = ::DefWindowProc;
        wndcls.cbClsExtra       = wndcls.cbWndExtra = 0;
        wndcls.hInstance        = hInst;
        wndcls.hIcon            = NULL;
        wndcls.hCursor          = AfxGetApp()->LoadStandardCursor(IDC_ARROW);
        wndcls.hbrBackground    = (HBRUSH) (COLOR_3DFACE + 1);
        wndcls.lpszMenuName     = NULL;
        wndcls.lpszClassName    = GRIDCTRL_CLASSNAME;

        if (!AfxRegisterClass(&wndcls)) {
            AfxThrowResourceException();
            return FALSE;
        }
    }

    return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// *** Destruction
/////////////////////////////////////////////////////////////////////////////

ccdbGrid::~ccdbGrid()
{
	//Delete all data in the m_gridColumns
	while( m_gridColumns.GetSize() )
	{		
		delete m_gridColumns[0];
		m_gridColumns.RemoveAt(0);
	}

	//Delete all data in the m_gridRows
	while( m_gridRows.GetSize() )
	{
		delete m_gridRows[0];
		m_gridRows.RemoveAt(0);
	}
	
    DestroyWindow();
}

/////////////////////////////////////////////////////////////////////////////
// *** General Attributes
/////////////////////////////////////////////////////////////////////////////

void ccdbGrid::setDD( ccDataDictionary * aoDD )		
{ 
	m_dd = aoDD;
	getDD()->setConfirmSaveMsg( 0 );			// TODO kanske bara ska gras fr gridden ej fr dd:t
	getDD()->setConfirmClearMsg( 0 );	
}	

//

int ccdbGrid::getRowHeight()
{    
    CDC* pDC = GetDC();
    if (pDC) 
    {        
        CFont* pOldFont = pDC->SelectObject(&m_gridFont);
        
        TEXTMETRIC tm;
        pDC->GetTextMetrics(&tm);
                
        pDC->SelectObject(pOldFont);
        ReleaseDC(pDC);

        return tm.tmHeight+tm.tmExternalLeading+ m_cellMargin ;
    }
	return 0;
}

//

void ccdbGrid::initCellMargin()
{
	//Get the cell margin
    CDC* pDC = GetDC();
    if (pDC) 
    {       
		
        CFont* pOldFont = pDC->SelectObject(&m_gridFont);
        m_cellMargin = pDC->GetTextExtent(_T(" "),1 ).cx;
        pDC->SelectObject(pOldFont);
        ReleaseDC(pDC);        
    }
	else
		m_cellMargin = 3;
}

//

void ccdbGrid::initVisibleGridRows( int aiGridHeight )
{
	if (aiGridHeight == 0)
		m_nVisibleGridRows = 0;
	else
	{
		m_nVisibleGridRows = aiGridHeight / getRowHeight() -1;
		if ( isInputTopRowAllowed() )
			m_nVisibleGridRows -= 1;	
	}	
}

//

int ccdbGrid::getTextWidth(CString& asText)
{
	//Get the label width
    CDC* pDC = GetDC();
    if (pDC) 
    {        
        CFont* pOldFont = pDC->SelectObject(&m_gridFont);
        int lfontSize = pDC->GetTextExtent(asText,asText.GetLength()).cx;
        pDC->SelectObject(pOldFont);
        ReleaseDC(pDC);

        return lfontSize + m_cellMargin ;
    }
	return 0;
}

//
void ccdbGrid::loadUnSelectedContactFloatMenu(int aiMenuID)
{
	m_unselectedItemMenuID = aiMenuID;
}

//

void ccdbGrid::loadSelectedItemFloatMenu(int aiMenuID)
{
	m_selectedItemMenuID = aiMenuID;

	for (int liCol = 0; liCol < m_gridColumns.GetSize();liCol++)
		m_gridColumns[liCol]->m_editCtrl->setFloatMenuID( m_selectedItemMenuID );
}

/////////////////////////////////////////////////////////////////////////////
// *** Drawing
/////////////////////////////////////////////////////////////////////////////

void ccdbGrid::OnDraw(CDC *pDC)
{				
	if ( !m_gridClipRect.IsRectEmpty() )
	{				
		CRect lSaveGridClipRect = m_gridClipRect;
		//Write the background
		eraseBkgnd(pDC);            // OnEraseBkgnd does nothing, so erase bkgnd here.
									// This is necessary since we may be using a Memory DC.		
		
		if ( m_nVisibleGridCols == 0 || getVisibleGridRows() == 0 )
			return;
		
		// Write the labels, The Column headers in the grid.
		writeLabels( pDC );		

		// Write the data cells	
		for (int liRow = 0; liRow < getVisibleGridRows(); liRow++)
		{
			//if ( liRow != m_idCurrentCell.y)
				drawRow(liRow, pDC);
		}

		m_gridClipRect = lSaveGridClipRect;
	}
}

//

void ccdbGrid::eraseBkgnd(CDC *pDC)
{    
    CBrush lLabelRowBrush( getLabelRowBkColor() ),
		   lTopRowInputBrush( getInputRowColor() ),           
           lNonDataRowsBrush( getBkColor() ),
		   lBorderBrush( getPenColor() );		 
		
	// Draw border
    pDC->FrameRect(CRect(m_gridClipRect.left, m_gridClipRect.top,
                         m_gridClipRect.right, m_gridClipRect.bottom ),
						 &lBorderBrush);	

	m_gridClipRect.DeflateRect(1, 1);


	// Draw Label Row BackGround	
    pDC->FillRect(CRect(m_gridClipRect.left, m_gridClipRect.top,
                        m_gridClipRect.right, m_gridClipRect.top + getRowHeight() ),
						 &lLabelRowBrush);	
	// Draw label Row Border
    pDC->Draw3dRect(CRect(m_gridClipRect.left, m_gridClipRect.top,
                         m_gridClipRect.right, m_gridClipRect.bottom ),
						 ::GetSysColor( COLOR_3DHILIGHT  ), ::GetSysColor( COLOR_BTNHILIGHT  ) );


	//Draw Top Row Input BackGround
	if ( isInputTopRowAllowed() )
	{
		// Draw the background		
		pDC->FillRect(CRect(m_gridClipRect.left, m_gridClipRect.top + getRowHeight(),
			                m_gridClipRect.right, m_gridClipRect.top + (getRowHeight()*2) ),
							 &lTopRowInputBrush);
		
		// Draw delimiter between Input row and Data Rows
		pDC->FillRect(CRect(m_gridClipRect.left, m_gridClipRect.top + (getRowHeight()*2),
			                m_gridClipRect.right, m_gridClipRect.top + (getRowHeight()*2) + m_cellMargin ),
							 &lLabelRowBrush);

		//
		// Draw the lines between cells.
		//
						
		//Draw the columns
		CRect lColumnPos( 0, m_inputTopRowYPos.x, 0, m_inputTopRowYPos.y );
		
		for (int i = 0; i < m_gridColumns.GetSize(); i++)
		{	
			lColumnPos.left  = m_cellXPos[i];
			lColumnPos.right = lColumnPos.left + m_gridColumns[i]->getWidth();
			
			//Don't go outside the gridcontrol 
			if ( i > m_nVisibleGridCols )
				break;

			//Draw a line between the labels
			CRect rect = lColumnPos;
			CPen  darkpen(PS_SOLID,  1,  getLabelRowBkColor( )),
				 *pOldPen = pDC->GetCurrentPen();

			pDC->SelectObject(&darkpen);
			pDC->MoveTo( rect.right, rect.top    + 2 );
			pDC->LineTo( rect.right, rect.bottom - 2 );

			pDC->SelectObject(pOldPen);
			rect.DeflateRect(1,1);		
			rect.left+= m_cellMargin;			
		}	

	}

	//Draw Non Data Rows BackGround
	CRect lNonDataRowRect = CRect(m_gridClipRect.left,  m_gridClipRect.top + getRowHeight(),
	                              m_gridClipRect.right, m_gridClipRect.bottom );

	if ( isInputTopRowAllowed() )
		lNonDataRowRect.top += getRowHeight()+ m_cellMargin;

	pDC->FillRect(lNonDataRowRect, &lNonDataRowsBrush);
}

//

void ccdbGrid::writeLabels(CDC *pDC)
{	
	int nSavedDC = pDC->SaveDC();

	//Set attributes for the label text
	pDC->SetTextColor( getLabelRowTextColor() );
	pDC->SetBkColor( getLabelRowBkColor() );
	
    pDC->SelectObject( &m_gridFont );

	//Draw the columns
	CRect lColumnPos( 0, m_gridClipRect.top, 0, getRowHeight() );
	
	for (int i = 0; i < m_gridColumns.GetSize(); i++)
	{	
		lColumnPos.left  = m_cellXPos[i];
		lColumnPos.right = lColumnPos.left + m_gridColumns[i]->getWidth();
		
		//Don't go outside the gridcontrol 
		if ( i > m_nVisibleGridCols )
			break;

		//Draw a line between the labels
		CRect rect = lColumnPos;
		CPen  darkpen(PS_SOLID,  1,  getPenColor( )),
			 *pOldPen = pDC->GetCurrentPen();

		pDC->SelectObject(&darkpen);
		pDC->MoveTo( rect.right, rect.top    + 2 );
		pDC->LineTo( rect.right, rect.bottom - 2 );

		pDC->SelectObject(pOldPen);
		rect.DeflateRect(1,1);		
		rect.left+= m_cellMargin;

		pDC->DrawText( m_gridColumns[i]->getName(), rect, DT_LEFT | DT_BOTTOM );		
	}	

	pDC->RestoreDC( nSavedDC );
}

//

void ccdbGrid::drawRow(int aiRow, CDC *pDC /*= NULL */)
{
	if (aiRow == -2)
		return;
	ANEEDVALUE( pDC );

    if (pDC)
    {	
		//Draw the cells	
		for (int liCol = 0; liCol < m_gridColumns.GetSize(); liCol++)
		{					
			//Don't go outside the gridcontrol 
			if ( liCol < getVisibleGridCols() )
				drawCell( liCol, aiRow, pDC );
			else
				break;			
		}		
	}
}

//

void ccdbGrid::drawCell(int aiCol, int aiRow, CDC *pDC /*= NULL */)
{
	// Not valid cell, or invisible cell
	if ( !isValidCell(aiCol, aiRow ) )
		return;

	
	if (aiRow < m_gridRows.GetSize() )
	{			
		ANEEDVALUE(pDC );

		if (pDC)
		{	
			CRect rect = getCellRectFromPos(aiCol, aiRow);

			CBrush lDataRowsBrush( getCellRowBkColor() );
				
			//Draw around the cell
			CPen  darkpen(PS_SOLID,  1, getPenColor() );
			CPen *pOldPen = pDC->GetCurrentPen();
			pDC->SelectObject(&darkpen);
			pDC->MoveTo(rect.right, rect.top);
			pDC->LineTo(rect.right, rect.bottom);
			pDC->LineTo(rect.left, rect.bottom);
			pDC->LineTo(rect.left, rect.top);
			pDC->LineTo(rect.right, rect.top);
			pDC->SelectObject(pOldPen);		

			//Draw the background inside the lines or rectangle	
			rect.DeflateRect(1,1,0,0);
			pDC->FillRect(rect, &lDataRowsBrush);
			rect.InflateRect(1,1,0,0);
			
			//Set attributes for the cell text
			pDC->SetTextColor( getCellRowTextColor() );
			pDC->SetBkColor( getCellRowBkColor() );	
			pDC->SelectObject( &m_gridFont );
			rect.DeflateRect(1,1);

			//Draw the text
			cGridRow *lGridRow = m_gridRows[aiRow];
			if ( lGridRow->m_cellData.GetSize() > aiCol )
				pDC->DrawText( lGridRow->m_cellData[aiCol], rect, DT_LEFT | DT_BOTTOM );		
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// *** Overrides
/////////////////////////////////////////////////////////////////////////////

BOOL ccdbGrid::upRow()
{
	if ( getDD()->isModified() )		
		saveRow();			

	if ( m_idCurrentCell.y < 0 )
	{
		ASSERT( getDD() != NULL );
		
		m_idCurrentCell.y++;	

		int liRow = 0;

		getDD()->getRS()->Bookmark = m_gridRows[ liRow ]->m_bookMark ;
		getDD()->getRS()->MovePrevious();

		if ( !getDD()->isBOF() )
		{	
			// Whitout this code and using the code down here, the grid will
			// Won't fill the m_gridRows correctley, after some OnSize stuff.
			m_gridRows[0]->m_bookMark = getDD()->getRS()->Bookmark;
			refillGrid();
			Invalidate();
			/*
			//Create a new row in the grid
			m_gridRows.InsertAt(liRow, new cGridRow );
			
			getDD()->GetBookmark( m_gridRows[liRow]->m_bookMark );

			//Insert data from the table row to the grid row	
			readRowFromTable( liRow );

			//Delete the first row
			delete m_gridRows[m_gridRows.GetSize()-1];
			m_gridRows.RemoveAt(m_gridRows.GetSize()-1);

			//ScrollUp row 0 to maxrow-1
			CRect ldataRowRect = m_dataRowRect;
			ldataRowRect.top += getRowHeight();

			ScrollWindow(0, getRowHeight(),m_dataRowRect ,ldataRowRect );

			//Don't update the uncovered area, remove the updare rect from the cwnd
			CRect lRemoveRect;
			ValidateRect( &lRemoveRect );*/
		}
		else
		{
			m_gridRows.FreeExtra();
			if (isInputTopRowAllowed() && m_idCurrentCell.y == 0)
				m_idCurrentCell.y = -2;

			return false;
		}
	}
	return true;
}

//

BOOL ccdbGrid::downRow()
{
	if ( getDD()->isModified() )		
		saveRow();			

	//Should we scroll down the grid one row.
	if ( m_idCurrentCell.y > ( getVisibleGridRows() -1 ) )
	{
		ASSERT( getDD() != NULL );
		
		m_idCurrentCell.y--;

		int liRow = m_gridRows.GetSize()-2;


		getDD()->getRS()->Bookmark = m_gridRows[ liRow ]->m_bookMark ;
		getDD()->getRS()->MoveNext();
		
		if ( !getDD()->isEOF() )
		{
			liRow++;
			//Create a new row in the grid
			m_gridRows.Add( new cGridRow );
			
			m_gridRows[liRow]->m_bookMark = getDD()->getRS()->Bookmark;

			//Insert data from the table row to the grid row	
			readRowFromTable( liRow );

			//Delete the first row
			delete m_gridRows[0];
			m_gridRows.RemoveAt(0);		

			//ScrollUp row 0 to maxrow-1
			CRect ldataRowRect = m_dataRowRect;
			ldataRowRect.bottom -= getRowHeight();

			ScrollWindow(0, -getRowHeight(),m_dataRowRect ,ldataRowRect );
		}
		else
		{
			m_gridRows.FreeExtra();
			return false;
		}
	}

	return true;
}

//

void ccdbGrid::changeRow()
{	
	//If the new current cell is on a diffrent row then the old current cell, reload the row from the database
	//if ( m_idCurrentCell.y != aOldCell.y)
	if ( m_idCurrentCell.y != -1)
	{					
		if ( m_gridRows.GetSize() > m_idCurrentCell.y)
		{			
			//Update the row, Maybe it has been changed by another user				
			getDD()->requery(); //Should be here, but things would be to slow....
			refillGrid();

			// If topInputRow
			if (m_idCurrentCell.y == -2)			
				getDD()->clearRecord();			
			else
				getDD()->getRS()->Bookmark = m_gridRows[m_idCurrentCell.y]->m_bookMark ;
						
			calcInplaceCtrlPos();			

			if ( m_idCurrentCell.x != -1)
				m_gridColumns[ m_idCurrentCell.x ]->m_editCtrl->SetFocus();				

			// Redraw the last slected row when holding down arrow down/up
			CPaintDC dc(this);      
			drawRow(m_idOldCurrentCell.y, &dc);

			// Redraw all data items after releasing down/up arrow
			Invalidate();
		}
		else
			m_idCurrentCell.y--;				
	}
}

//

void ccdbGrid::saveRow()
{
	getDD()->saveRecord();
}

//

void ccdbGrid::OnSelectCell(CPoint aSelectedCell)
{	
	SendMessageToParent(aSelectedCell.x, aSelectedCell.y, GVN_SELECTED);
}

//

void ccdbGrid::OnEditCell(int nCol, int nRow, UINT nChar)
{	
	if ( isValidCell(nCol, nRow ) )
	{		
		m_gridColumns[nCol]->m_editCtrl->SetFocus();
	}
}


//

/////////////////////////////////////////////////////////////////////////////
// *** Implementation
/////////////////////////////////////////////////////////////////////////////

void ccdbGrid::firstRow()
{
	if ( getDD()->isModified() )		
		saveRow();			

	ASSERT( getDD() != NULL );
		
	//Delete all data in the m_gridRows
	while( m_gridRows.GetSize() )
	{
		delete m_gridRows[0];
		m_gridRows.RemoveAt(0);
	}

	//Check if any records in the table
	if ( getDD()->isBOF() )
		return;

	getDD()->getRS()->MoveFirst();

	for( int liRow = 0; liRow <= getVisibleGridRows(); liRow++)
	{		
		//Break if no more data in the table
		if ( getDD()->isEOF() )
			break;

		//Create a new row in the grid
		m_gridRows.Add( new cGridRow );
		
		m_gridRows[liRow]->m_bookMark = getDD()->getRS()->Bookmark;

		//Insert data from the table row to the grid row	
		readRowFromTable( liRow );

		//Move to next table row
		getDD()->getRS()->MoveNext();
	}
}

//

void ccdbGrid::moveRow( E_CCGR_MR aMoveRow )
{
	if ( getDD()->isModified() )		
		saveRow();			

	ASSERT( getDD() != NULL );
		
	if ( aMoveRow == CCGR_MRLASTROW )
		getDD()->getRS()->MoveLast();
	else
		getDD()->getRS()->Bookmark = m_gridRows[0]->m_bookMark ;

	// Go back visible number of rows.
	for( int liRow = 0; liRow < getVisibleGridRows(); liRow++)
	{
		//Break if no more data in the table
		if ( getDD()->isBOF() )
		{
			m_idCurrentCell.y = 0;
			getDD()->getRS()->MoveFirst();
			break;
		}

		if ( getDD()->isEOF() )
		{
			m_idCurrentCell.y = (getVisibleGridRows() -1);
			lastRow();
			return;			
		}

		switch ( aMoveRow )
		{
		case CCGR_MRLASTROW:
		case CCGR_MRPAGEUPROW:
			getDD()->getRS()->MovePrevious();
			break;		
		case CCGR_MRPAGEDOWNROW:
			getDD()->getRS()->MoveNext();
			break;
		default:
			ccErr( IDS_IMP_ERROR_WRONG_ECCGR_MR );
		}
	}

	//Delete all data in the m_gridRows
	while( m_gridRows.GetSize() )
	{
		delete m_gridRows[0];
		m_gridRows.RemoveAt(0);
	}

	//Check if any records in the table
	if ( getDD()->isBOF() )
		return;

	// Read the rows
	for( liRow = 0; liRow <= getVisibleGridRows(); liRow++)
	{		
		//Break if no more data in the table
		if ( getDD()->isEOF() )
			break;

		//Create a new row in the grid
		m_gridRows.Add( new cGridRow );
		
		m_gridRows[liRow]->m_bookMark = getDD()->getRS()->Bookmark;

		//Insert data from the table row to the grid row	
		readRowFromTable( liRow );

		//Move to next table row
		getDD()->getRS()->MoveNext();
	}
}

//

void ccdbGrid::lastRow()
{
	moveRow( CCGR_MRLASTROW );
}

//

void ccdbGrid::pageUpRow()
{
	moveRow( CCGR_MRPAGEUPROW );
}

//

void ccdbGrid::pageDownRow()
{
	moveRow( CCGR_MRPAGEDOWNROW );
}

//

void ccdbGrid::readRowFromTable(int aiRow)
{
	m_gridRows[aiRow]->m_cellData.RemoveAll();
	m_gridRows[aiRow]->m_cellData.SetSize( m_ccFields.GetSize() );
	for (int liCol = 0; liCol < m_ccFields.GetSize();liCol++)
		m_gridRows[aiRow]->m_cellData[liCol] = ( m_ccFields.GetAt(liCol)->getValue()  );			
}

//

LRESULT ccdbGrid::SendMessageToParent(int nCol, int nRow, int nMessage)
{
    if (!IsWindow(m_hWnd))
        return 0;

    NM_GRIDVIEW nmgv;
    nmgv.iRow         = nRow;
    nmgv.iColumn      = nCol;

	if ( isValidCell(nCol, nRow ) && nRow != -2  )
		nmgv.m_bookMark = getDD()->getRS()->Bookmark;

    nmgv.hdr.hwndFrom = m_hWnd;
    nmgv.hdr.idFrom   = GetDlgCtrlID();
    nmgv.hdr.code     = nMessage;

    CWnd *pOwner = GetOwner();
    if (pOwner && IsWindow(pOwner->m_hWnd))
        return pOwner->SendMessage(WM_NOTIFY, nmgv.hdr.idFrom, (LPARAM)&nmgv);
    else
        return 0;
}

//

void ccdbGrid::calcInplaceCtrlPos()
{
	if ( m_gridColumns.GetSize() > 0)
	{
		int liRow = m_idCurrentCell.y;
		if (liRow == -1)
			liRow = 0;
		for( int liCol=0; liCol < m_gridColumns.GetSize(); liCol++)
		{
			CRect lRect = getCellRectFromPos( liCol,liRow );

			// Place the super ctrl inside the grid lines. and not on any grid line
			lRect.DeflateRect(1,1,0,0);			

			DWORD dwStyle = ES_LEFT;	
			
			m_gridColumns[liCol]->m_editCtrl->setPos( lRect, liCol, liRow);		
		}
	}
}

//

void ccdbGrid::refillGrid()
{
	ASSERT( getDD() != NULL );
	if ( getDD()->isModified() )		
		saveRow();			

	if ( m_gridRows.GetSize() > 0)
		getDD()->getRS()->Bookmark = m_gridRows[0]->m_bookMark ;
	else
		getDD()->getRS()->MoveFirst();


	//Delete all data in the m_gridRows
	while( m_gridRows.GetSize() )
	{
		delete m_gridRows[0];
		m_gridRows.RemoveAt(0);
	}

	//Check if any records in the table
	if ( getDD()->isBOF() )
		return;	

	for( int liRow = 0; liRow <= getVisibleGridRows(); liRow++)
	{		
		//Break if no more data in the table
		if ( getDD()->isEOF() )
			break;

		//Create a new row in the grid
		m_gridRows.Add( new cGridRow );
		
		m_gridRows[liRow]->m_bookMark = getDD()->getRS()->Bookmark;

		//Insert data from the table row to the grid row	
		readRowFromTable( liRow );

		//Move to next table row
		getDD()->getRS()->MoveNext();
	}
}

//

void ccdbGrid::refreshGrid()
{
	//Check if any records in the table
	if ( getDD()->isBOF() )
		return;	

	getDD()->requery();
	refillGrid();
	if ( (m_idCurrentCell.y != -1) && (!isValidCell( m_idCurrentCell.x, m_idCurrentCell.y )) )
	{
		m_idCurrentCell.y=getVisibleGridRows();
	}

	if  (m_idCurrentCell.y != -1)
	{		
		ASSERT( m_gridRows.GetSize() > m_idCurrentCell.y );
		getDD()->getRS()->Bookmark = m_gridRows[m_idCurrentCell.y]->m_bookMark ;
	}
}

//

CString ccdbGrid::getCellText(int nCol, int nRow)
{
	if ( isValidCell(nCol, nRow) )
		return m_gridRows[nRow]->m_cellData[nCol];
	else
		return CString();
}

//

void ccdbGrid::setCellText(int nCol, int nRow, CString & str)
{
	// This method doesn't work on top input row
	if ( nRow != -2)
	{
		if ( isValidCell(nCol, nRow) )
		{	
			CString strCurrent = getCellText(nCol, nRow);
			if (strCurrent != str)
			{						
				m_gridRows[nRow]->m_cellData[nCol] = str;
			}
		}
	}
}

//

BOOL ccdbGrid::isValidCell(int aiCol, int aiRow)
{	
	// Check the topInputRow.
	if ( isInputTopRowAllowed() &&
		 aiRow == -2 &&
		(aiCol >= 0)									  && (aiCol < getVisibleGridCols() )  
		//(m_gridRows[0]->m_cellData.GetSize() > 0)     && (aiCol < m_gridRows[aiRow]->m_cellData.GetSize()) 
       )
	   return TRUE;


	// Check if column is valid
	if (
		(aiCol >= 0)									  && (aiCol < getVisibleGridCols() )  && 				
		(aiRow >= 0)									  && (aiRow < getVisibleGridRows() )  &&		
		(m_gridRows.GetSize() > 0)                        && (aiRow < m_gridRows.GetSize())   &&
		(m_gridRows[aiRow]->m_cellData.GetSize() > 0)     && (aiCol < m_gridRows[aiRow]->m_cellData.GetSize()) 
	   )		
		return TRUE;
	else
		return FALSE;		
}

//

void ccdbGrid::calcCellPos()
{		
	m_nVisibleGridCols = -1;

	m_cellXPos.RemoveAll();
	m_cellXPos.SetSize( m_gridColumns.GetSize() );

	//The pixel rect for the top, left cell.
	CRect lCellPos(m_gridClipRect.left ,m_gridClipRect.top ,m_gridClipRect.right, m_gridClipRect.top+getRowHeight() );	
	
	// calculate cell x Pos
	for (int liCol = 0; liCol < m_gridColumns.GetSize(); liCol++)
	{				
		if ( (m_nVisibleGridCols == -1) && (lCellPos.left >=m_gridClipRect.right) )
			m_nVisibleGridCols = liCol;

		m_cellXPos[liCol] = lCellPos.left;

		lCellPos.left += m_gridColumns[liCol]->getWidth();
	}	
	
	if ( m_nVisibleGridCols == -1 )
		m_nVisibleGridCols = m_gridColumns.GetSize();


	// calculate cell y Pos
	initVisibleGridRows( m_gridClipRect.Height() );
	m_cellYPos.RemoveAll();
	m_cellYPos.SetSize( getVisibleGridRows()+1 );

	if (isInputTopRowAllowed() )
	{
		lCellPos.top        = m_gridClipRect.top + (getRowHeight()*2) + m_cellMargin;	
		m_inputTopRowYPos.x = m_gridClipRect.top + getRowHeight();
		m_inputTopRowYPos.y = m_gridClipRect.top + (getRowHeight()*2);	
	}
	else
	{
		lCellPos.top   = m_gridClipRect.top + getRowHeight();
		m_inputTopRowYPos.x = -1;
		m_inputTopRowYPos.y = -1;
	}

	for (int liRow = 0; liRow <= getVisibleGridRows(); liRow++)
	{
		m_cellYPos[liRow] = lCellPos.top;
		lCellPos.top     += getRowHeight();
	}
}

//

CPoint ccdbGrid::getCellPosFromPt(CPoint aPoint)
{
	CPoint lCellPos(-1,-1);

	//The pixel rect for the top, left cell.
	CRect lCellRect;
	// calculate column index
	for (int liCol = 0; liCol < m_gridColumns.GetSize(); liCol++)
	{			
		lCellRect.left  = m_cellXPos[liCol];
		lCellRect.right = lCellRect.left + m_gridColumns[liCol]->getWidth();
	
		//Don't go outside the gridcontrol 
		if ( liCol > m_nVisibleGridCols )
			break;
		
		if ( (aPoint.x > lCellRect.left) && (aPoint.x < lCellRect.right) )
		{
			lCellPos.x = liCol ;
			break;
		}
	}	

	// calculate row index
	for (int liRow = 0; liRow < getVisibleGridRows(); liRow++)
	{
		lCellRect.top    = m_cellYPos[liRow];
		lCellRect.bottom = lCellRect.top + getRowHeight();

		if ( (aPoint.y > lCellRect.top) && (aPoint.y < lCellRect.bottom) )
		{
			lCellPos.y = liRow;
			break;
		}			
	}
	
	// Check if the aPoint is in the topInputRow
	if ( isInputTopRowAllowed() )
	{
		if ( (aPoint.y > m_inputTopRowYPos.x) && (aPoint.y < m_inputTopRowYPos.y) )
		{
			lCellPos.y = -2;  // The topInputRow was pressed.			
		}			
	}	
	
	return lCellPos;
}

//

CRect ccdbGrid::getCellRectFromPos(int aiCol, int aiRow)
{	
	CRect lRect;
	if ( (m_cellXPos.GetSize() > 0) && (m_cellYPos.GetSize() > 0))
	{
		lRect.left  = m_cellXPos[aiCol];
		lRect.right = lRect.left + m_gridColumns[aiCol]->getWidth();

		if ( isInputTopRowAllowed() && aiRow == -2)
		{
			lRect.top    = m_inputTopRowYPos.x;
			lRect.bottom = m_inputTopRowYPos.y;
		}
		else
		{
			lRect.top    = m_cellYPos[aiRow];
			lRect.bottom = lRect.top + getRowHeight();
		}
	}

	return lRect;
}

/////////////////////////////////////////////////////////////////////////////
// *** Generated message map functions
/////////////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP(ccdbGrid, CWnd)
	//{{AFX_MSG_MAP(ccdbGrid)
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_KEYDOWN()
	ON_WM_SETFOCUS()
	ON_WM_CONTEXTMENU()
	ON_WM_ERASEBKGND()
	ON_WM_KILLFOCUS()
	ON_WM_VSCROLL()
	//}}AFX_MSG_MAP
	ON_NOTIFY(GVN_ENDLABELEDIT, IDC_INPLACE_CONTROL, OnEndInPlaceEdit)	
END_MESSAGE_MAP()

//

void ccdbGrid::OnPaint() 
{		
    CPaintDC dc(this);      // device context for painting	

	if (m_bDoubleBuffer)    // Use a memory DC to remove flicker
    {
        CMemDC MemDC(&dc);
        OnDraw(&MemDC);
    }
    else                    // Draw raw - this helps in debugging vis problems.
		OnDraw(&dc);
}

//

void ccdbGrid::OnSize(UINT nType, int cx, int cy) 
{	
	CWnd::OnSize(nType, cx, cy);
	

	m_clipRect.left   = 0;
	m_clipRect.top    = 0;
	m_clipRect.right  = cx;
	m_clipRect.bottom = cy;
	
	initVisibleGridRows( cy );
	if ( getVisibleGridRows() != 0)
	{
		calcCellPos();

		//Todo temporary		
		refreshGrid();
	}		

	if ( isInputTopRowAllowed() )
		m_dataRowRect = CRect(m_clipRect.left,  m_clipRect.top + (getRowHeight()*2) + m_cellMargin,
			                  m_clipRect.right, ( (getVisibleGridRows()+2)*getRowHeight())+m_clipRect.top+m_cellMargin );	
	else
		m_dataRowRect = CRect(m_clipRect.left,  m_clipRect.top + getRowHeight(),
			                  m_clipRect.right, ( (getVisibleGridRows()+1)*getRowHeight() )+m_clipRect.top );	
}

//

void ccdbGrid::OnLButtonDblClk(UINT nFlags, CPoint point) 
{	
	SendMessageToParent(-1, -1, GVN_SELECTED);
	CWnd::OnLButtonDblClk(nFlags, point);
}

//

void ccdbGrid::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CPoint lCellPos = getCellPosFromPt( point);
	OnEditCell( lCellPos.x, lCellPos.y,VK_LBUTTON);	
	
	CWnd::OnLButtonUp(nFlags, point);	
}

//

void ccdbGrid::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// Set focus to the grid, must be done if the last ctrl was an ccInplaceEdit
	// or else that ctrls killfocus won't be exectued in right order
	SetFocus();

	//If label is clicked change sortorder to that column

	//If any cell is clicked mark that as currentCell	
	m_idCurrentCell = getCellPosFromPt(point);
	if (isValidCell(m_idCurrentCell.x, m_idCurrentCell.y)) 
	{	
		if ( getDD()->isModified() )		
			saveRow();			
		
		changeRow( );		
	}
	
	CWnd::OnLButtonDown(nFlags, point);
}

//

void ccdbGrid::OnRButtonDown(UINT nFlags, CPoint point) 
{
	OnLButtonDown(nFlags, point);
	OnLButtonUp(nFlags, point);

	//CPoint lCellPos = getCellPosFromPt( point);
	//m_gridColumns[lCellPos.x]->m_editCtrl->OnRButtonDown(nFlags, point);

	CWnd::OnRButtonDown(nFlags, point);
}

//

void ccdbGrid::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
    if (!isValidCell(m_idCurrentCell.x, m_idCurrentCell.y)) 
    {
        CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
        return;
    }
	
	m_idOldCurrentCell = m_idCurrentCell;
	
    switch (nChar)
    {
        case VK_DELETE: 
			break;

        case VK_RETURN: 
			OnSelectCell( m_idCurrentCell );
			break;
			
        case VK_TAB:    
            if (isSHIFTPressed())
            {
				OnKeyDown(VK_LEFT, 0, 0);
            }
            else
            {
				OnKeyDown(VK_RIGHT, 0, 0);				
            } 
            break;
        case VK_DOWN:   
            if (m_idCurrentCell.y < getVisibleGridRows())
                m_idCurrentCell.y++; 
				
			if ( m_gridRows.GetSize() > m_idCurrentCell.y)
			{
				downRow();
				changeRow( );				//Draw marker and update the new row
			}
			else
				m_idCurrentCell.y--; 
            break;            
            
        case VK_UP:     		
            if (m_idCurrentCell.y > -1)
                m_idCurrentCell.y--; 

			upRow();
			changeRow( );				//Draw marker and update the new row									
            break;

        case VK_LEFT:
                if (m_idCurrentCell.x > 0) 
                    m_idCurrentCell.x--;
                else 
					if (m_idCurrentCell.x == 0 && 
						m_idCurrentCell.y > -1) 
					{
						m_idCurrentCell.x = ( m_nVisibleGridCols-1)  ; 						
						m_idCurrentCell.y--; 						
							
						if ( !upRow() )
						{							
							m_idCurrentCell.x = 0;
						}

						changeRow( );				//Draw marker and update the new row
					}
					else
						CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
            break;
            
        case VK_RIGHT:  
                if (m_idCurrentCell.x < ( m_nVisibleGridCols-1)) 
                    m_idCurrentCell.x++;
                else 
					if (m_idCurrentCell.x == ( m_nVisibleGridCols-1) && 
                         m_idCurrentCell.y < getVisibleGridRows() )
					{
						m_idCurrentCell.x = 0;
						m_idCurrentCell.y++; 
						if ( m_gridRows.GetSize() > m_idCurrentCell.y)
						{							
							if ( !downRow() )
								m_idCurrentCell.x = ( m_nVisibleGridCols-1);
							changeRow( );				//Draw marker and update the new row
						}
						else
							m_idCurrentCell.y--; 
					}
					else
						CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
            break;
		case VK_HOME:
			m_idCurrentCell.y = 0;			
			firstRow();
			Invalidate();
			changeRow( );				//Draw marker and update the new row
			break;
		case VK_END:
			m_idCurrentCell.y = (getVisibleGridRows() -1);
			lastRow();
			Invalidate();
			changeRow( );				//Draw marker and update the new row
			break;
		case VK_PRIOR:			
			pageUpRow();
			changeRow( );				//Draw marker and update the new row			
			break;
		case VK_NEXT:					
			pageDownRow();			
			changeRow( );				//Draw marker and update the new row
			break;
        default:
            CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
    }

}

//

void ccdbGrid::OnSetFocus(CWnd* pOldWnd) 
{
	CWnd::OnSetFocus(pOldWnd);

	if (!isValidCell( m_idCurrentCell.x, m_idCurrentCell.y) )
	{
		m_idCurrentCell = CPoint(0,0);
		changeRow();			
	}
}

//

void ccdbGrid::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	// if no menu, just return. 
	if (m_unselectedItemMenuID == -1 )
	{ 
		// Gonzalo Pereyra
		DefWindowProc(WM_CONTEXTMENU, LONG(m_hWnd), 
			MAKELPARAM(point.x,point.y)); 

		TRACE0(_T("Warning: No control bar menu defined.\n")); 
		return; 
	}

	if (point.x == -1 && point.y == -1)
	{
		//keystroke invocation
		CRect rect;
		GetClientRect(rect);
		ClientToScreen(rect);
		
		point = rect.TopLeft();
		point.Offset(5, 5);
	}
	
	CMenu menu;
	VERIFY(menu.LoadMenu(m_unselectedItemMenuID));
	
	CMenu* pPopup = menu.GetSubMenu(0);
	ASSERT(pPopup != NULL);
	CWnd* pWndPopupOwner = this;
	
	while (pWndPopupOwner->GetStyle() & WS_CHILD)
		pWndPopupOwner = pWndPopupOwner->GetParent();
	
	pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y,
		pWndPopupOwner);
}

//

BOOL ccdbGrid::OnEraseBkgnd(CDC* pDC) 
{
	return true;	// Remove some flicker
}

//

void ccdbGrid::OnEndInPlaceEdit(NMHDR *pNMHDR, LRESULT *pResult)
{
    GV_DISPINFO *pgvDispInfo = (GV_DISPINFO *)pNMHDR;
    GV_ITEM     *pgvItem = &pgvDispInfo->item;

    // In case OnEndInPlaceEdit called as window is being destroyed
    if (!IsWindow(GetSafeHwnd()))
        return;

	//Set current cell to the cell we're leaving,, OnKeyDown will set current cell to the new currentCell.
	m_idCurrentCell.x = pgvItem->col;
	m_idCurrentCell.y = pgvItem->row;

    setCellText(pgvItem->col, pgvItem->row, pgvItem->szText);	
    
    SendMessageToParent(pgvItem->col, pgvItem->row, GVN_ENDLABELEDIT);

    switch (pgvItem->lParam) 
    {
		case VK_RETURN:
			OnKeyDown(pgvItem->lParam, 0, 0);
			break;	
        case VK_TAB:		
        case VK_DOWN: 
        case VK_UP:   
        case VK_RIGHT:
        case VK_LEFT:  
        case VK_NEXT:  
        case VK_PRIOR: 
        case VK_HOME:  
        case VK_END:    
            OnKeyDown(pgvItem->lParam, 0, 0);
            OnEditCell(m_idCurrentCell.x, m_idCurrentCell.y, pgvItem->lParam);		
    }

    *pResult = 0;
}

//

void ccdbGrid::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{	
	switch( nSBCode )
	{

	case SB_BOTTOM:
		pScrollBar->SetScrollPos( 0 );
		break;

	case SB_ENDSCROLL:
		break;

	case SB_LINEDOWN:
		pScrollBar->SetScrollPos( pScrollBar->GetScrollPos()+1 );
		break;
		
	case SB_LINEUP:
		break;

	case SB_PAGEDOWN:
		break;

	case SB_PAGEUP:
		break;

	case SB_THUMBPOSITION:
		break;

	case SB_THUMBTRACK:
		break;

	case SB_TOP:
		break;
	}
	
	CWnd::OnVScroll(nSBCode, nPos, pScrollBar);
}
