//////////////////////////////////////////////////////////////////////
// $File name   : ccddCtrlContainer.cpp
//
// $Author      : Daniel Lindh (Daniel.Lindh@home.se)
// Notice       : Copyright (c) CyberCow 1999
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ccddCtrlContainer.h"
#include "resource.h"
#include "ccDataBase.h"
#include "ccdbSuperCtrl.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////
// *** Destruction
/////////////////////////////////////////////////////////////////////////////

ccddCtrlContainer::~ccddCtrlContainer()
{
	if (m_dbToolBar ) 
	{
		delete m_dbToolBar;
	}
}

/////////////////////////////////////////////////////////////////////////////
// *** Implementation
/////////////////////////////////////////////////////////////////////////////

void ccddCtrlContainer::createDBToolBar()
{
	if ( m_dbToolBar == NULL )
	{
		m_dbToolBar = new CCJToolBar;

		//Create Toolbar
		if (!m_dbToolBar->CreateEx(AfxGetMainWnd(), TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
			| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
			!m_dbToolBar->LoadToolBar( IDR_DB_TOOLBAR ))
		{
			TRACE0("Failed to create toolbar\n");
			return ;      // fail to create
		}
		m_dbToolBar->AddDropDownButton(IDDB_NEXT_ITEM    , IDR_DB_NEXT_ITEM, TRUE);	
		m_dbToolBar->AddDropDownButton(IDDB_PREVIOUS_ITEM, IDR_DB_PREV_ITEM, TRUE);	


		m_dbToolBar->EnableDocking(CBRS_ALIGN_ANY);
		CFrameWnd * pFrameWnd;
		pFrameWnd = (CFrameWnd*)AfxGetMainWnd();	
		pFrameWnd->EnableDocking(CBRS_ALIGN_ANY);
		pFrameWnd->DockControlBar(m_dbToolBar);
	}
}

/////////////////////////////////////////////////////////////////////////////
// *** Generated message map functions
/////////////////////////////////////////////////////////////////////////////

void ccddCtrlContainer::OnClear() 
{
	if (__getDB()->getCrntFocus() )
		__getDB()->getCrntFocus()->OnRecordClear();
}

//

void ccddCtrlContainer::OnDelete() 
{
	if (__getDB()->getCrntFocus() )
		__getDB()->getCrntFocus()->OnRecordDelete();	
}

//

void ccddCtrlContainer::OnFirstItem() 
{
	if (__getDB()->getCrntFocus() )
		__getDB()->getCrntFocus()->OnRecordFirst();	
}

//

void ccddCtrlContainer::OnLastItem() 
{
	if (__getDB()->getCrntFocus() )
		__getDB()->getCrntFocus()->OnRecordLast();
}

//

void ccddCtrlContainer::OnNextItem() 
{
	if (__getDB()->getCrntFocus() )
		__getDB()->getCrntFocus()->OnRecordNext();
}

//

void ccddCtrlContainer::OnPreviousItem() 
{
	if (__getDB()->getCrntFocus() )
		__getDB()->getCrntFocus()->OnRecordPrev();
}

//

void ccddCtrlContainer::OnPrompt() 
{
	if (__getDB()->getCrntFocus() )	
		__getDB()->getCrntFocus()->OnRecordPopup();	
}

//

void ccddCtrlContainer::OnRefresh() 
{
	if (__getDB()->getCrntFocus() )
		__getDB()->getCrntFocus()->OnRecordRefresh();
}

//

void ccddCtrlContainer::OnSave() 
{
	if (__getDB()->getCrntFocus() )
		__getDB()->getCrntFocus()->OnRecordSave();
}
