// ccException.cpp: implementation of the ccException class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ccglib.h"
#include "ccTime.h"
#include "ccException.h"
#include "ccString.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// *** Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_DYNAMIC(ccException, CException);

ccException::ccException(BOOL b_AutoDelete, UINT nResourceID, LPCSTR strSource, UINT nLine )
: CException( b_AutoDelete)
{
	m_nResourceID = nResourceID;	

	m_source = strSource;
	m_line = nLine;
	
	m_timeStamp = *((ccTime*)&CGoodTime::GetCurrentTime());
	m_process = AfxGetAppName();
}

//
ccException::ccException(BOOL b_AutoDelete, LPCSTR strError, LPCSTR strSource, UINT nLine )
: CException( b_AutoDelete)
{
	m_nResourceID = -1;	
	m_nDesc		  = strError;

	m_source = strSource;
	m_line = nLine;
	
	m_timeStamp = *((ccTime*)&CGoodTime::GetCurrentTime());
	m_process = AfxGetAppName();
}

//

ccException::~ccException()
{

}

//////////////////////////////////////////////////////////////////////
// *** Input/Output
//////////////////////////////////////////////////////////////////////

CString ccException::getDescription()
{
	if (m_nResourceID != -1)
	{
		CString str; 
		str.LoadString( getResourceID() ); 
		return str;							
	}
	else
		return m_nDesc;
}

//

CString ccException::getFullDescription()
{
	ccString str;
	str << "Exception ID: " << getResourceID() << "\n";
	str << "\t" << "Process: " << getProcess() << "\n";
	str << "\t" << "Source:  " << getSource()  << "\n";
	str << "\t" << "Line:    " << getLine()    << "\n";
	str << "\t" << "Time:    " << getTime()	   << "\n";	
	str << "\t" << "Description:\n";
	str << "\t" << getDescription() << "\n";

	return str;
}

//////////////////////////////////////////////////////////////////////
// *** Overloads
//////////////////////////////////////////////////////////////////////


BOOL ccException::GetErrorMessage( LPTSTR lpszError, UINT nMaxError, PUINT pnHelpContext )
{
	strncpy( lpszError, getDescription(), nMaxError);
	CString moo;
	
	if ( getDescription().GetLength() >= (int)nMaxError)
		lpszError[nMaxError] = '0';			

	if ( pnHelpContext != NULL)
		*pnHelpContext = 0;
	return true;
}

//

int ccException::ReportError( UINT nType, UINT nMessageID  )
{
	if ( nMessageID == 0 )
		return AfxMessageBox( getDescription(), nType,  0);
	else
		return AfxMessageBox( nMessageID, nType,  0);
}
