// ==========================================================================
//                    Class Specification : ccException
// ==========================================================================
//////////////////////////////////////////////////////////////////////
// $File name   : /ccLib/dev/ccgLib/ccException.h
//
// $Author      : Daniel Lindh (Daniel.Lindh@home.se)
// $HomePage    : home.bip.net/CyberCow
// $ICQ         : 7983755
//
// Notice       : Copyright (c) CyberCow 1999
//                Knypplerskevagen 24
//                168 38 BROMMA
//                SWEDEN  
//                tel int + 46 (8) 26 45 95
//                
//                The copyright to the computer program(s) herein is the 
//				  property of CyberCow.The program(s) may be used and/or 
//				  copied only with the written permission of CyberCow or 
//				  in accordance with the terms and conditions stipulated 
//				  in the agreement/contract under which the program(s) 
//				  have been supplied. 
//
/////////////////////////////////////////////////////////////////////////////
///** $History$ *************************************************************
// *
// * $Date: 9/03/99 10:17 $
// * $Revision: 11 $
// * 
// * *****************  Version 1  *****************
// * User: Daniel Date: 9/28/99 12:21
// * Source-Code Traced [ ]; Reviewd [ ] 
// * Created in $/ccLib/dev/ccgLib
// * Initial release.
// * 
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
// ** $Properties$ **********************************************************
// * [ ] Abstract class (does not have any objects)
// * [ ] Uses exceptions
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
/*
$Description : 

*/
/////////////////////////////////////////////////////////////////////////////

#ifndef __CCEXCEPTION_H__
#define __CCEXCEPTION_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ccTime.h"

class AFX_EXT_CLASS ccException  : public CException
{
// *** Construction/Destruction
public:
	// Default Constructor
	// 
	ccException(BOOL b_AutoDelete, UINT nResourceID, LPCSTR strSource, UINT nLine );

	ccException(BOOL b_AutoDelete, LPCSTR strError, LPCSTR strSource, UINT nLine );

	DECLARE_DYNAMIC(ccException)

	// Default destructor
	//
	virtual ~ccException();

// *** Input/Output
public:
	// Returns the errornumber/resourceID
	//
	int	getResourceID()					{ return m_nResourceID;					}

	// Return the text from the Stringresource the nResourceID is pointing to.
	// THE ERROR MESSAGE.
	//
	CString getDescription();

	// Return all data about the exception in a formated CString
	//
	CString getFullDescription();

	// Return full source (path+file) of the file where the Exception occured.
	//
	CString getSource()					{ return m_source;						}

	// Return the source code line from where the exception where throwed.
	//
	UINT	getLine()					{ return m_line;						}

	// Return the time when the exception where thrown;
	//
	ccTime	getTime()					{ return m_timeStamp;					}

	// Get the proccess (dll/exe file) in which the exception where thrown
	//
	CString getProcess()				{ return m_process;						}

// *** Overloads
public:
	virtual BOOL GetErrorMessage( LPTSTR lpszError, UINT nMaxError, PUINT pnHelpContext = NULL );
	virtual int ReportError( UINT nType = MB_OK, UINT nMessageID = 0 );

private:
	int	m_nResourceID;		// error number/code

	CString m_nDesc;		// Error message if the rescoureID is -1

	CString	m_source;		// full path + file
	UINT	m_line;			// line in file

	ccTime	m_timeStamp;	// time of error
	CString	m_process;		// name of process

/*	
	UINT type;			// jeDebug error? Win32 error? JEPP error? other?		
			
	int HelpContext		// Help id
	CString HelpFile	// Full path+file to a .hlp file.

	AfxAbort();	
*/
};

#define ccThrowccException(x) throw new ccException(true, x, __FILE__, __LINE__);

#endif // __CCEXCEPTION_H__
