// ccFlatSplitterWnd.cpp: implementation of the ccFlatSplitterWnd class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ccglib.h"
#include "ccFlatSplitterWnd.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////
// *** Operations
//////////////////////////////////////////////////////////////////////

BOOL ccFlatSplitterWnd::ReplaceView(int nRow, int nCol, CRuntimeClass *pViewClass, BOOL bAlwaysDeleteOldView /*= TRUE*/)
{
	CView *pView = DYNAMIC_DOWNCAST( CView, GetPane( nRow, nCol ));
	ASSERT_KINDOF( CView, pView );

	// If we're already displaying this kind of view, no need to go further.
	// But sometimes we always want to delete the old view.
	if ( bAlwaysDeleteOldView == FALSE )
		if( pView->IsKindOf( pViewClass ))
			return FALSE;

	// Get pointer to CDocument object so that it can be used in the creation
	// process of the new view
	CDocument *pDoc = pView->GetDocument();

	int nID = pView->GetDlgCtrlID();
	int nWidth, nHeight, nMinWidth, nMinHeight;

	GetRowInfo( nRow, nWidth, nMinWidth );
	GetColumnInfo( nCol, nHeight, nMinHeight );

	// Delete existing view
	DeleteView(nRow, nCol);

	// Create new view
	CCreateContext context;
	context.m_pCurrentDoc = pDoc;
	CreateView( nRow, nCol, pViewClass, CSize( nWidth, nHeight ), &context );
	pView = DYNAMIC_DOWNCAST( CView, GetPane( nRow, nCol ));
	ASSERT_KINDOF( CView, pView );

	pView->SetDlgCtrlID( nID );

	SetRowInfo( nRow, nWidth, nMinWidth );
	SetColumnInfo( nCol, nHeight, nMinHeight );
	RecalcLayout();

	pView->SendMessageToDescendants(WM_PAINT, 0, 0, TRUE, TRUE);
	pView->SendMessageToDescendants(WM_INITIALUPDATE, 0, 0, TRUE, TRUE);

	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// *** Overrides
//////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP(ccFlatSplitterWnd, CCJFlatSplitterWnd)
	//{{AFX_MSG_MAP(CCJFlatSplitterWnd)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//

void ccFlatSplitterWnd::OnDrawSplitter(CDC* pDC, ESplitType nType,
	const CRect& rectArg)
{	
	CCJFlatSplitterWnd::OnDrawSplitter(pDC, nType, rectArg);	
}