//////////////////////////////////////////////////////////////////////
// $File name   : ccMenuButton.cpp: 
//
// $Author      : Daniel Lindh (Daniel.Lindh@home.se)
// Notice       : Copyright (c) CyberCow 1999
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ccMenuButton.h"
#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(ccMenuButton, CButtonST)
	//{{AFX_MSG_MAP(ccMenuButton)		
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Properties
/////////////////////////////////////////////////////////////////////////////

void ccMenuButton::clearMenu()
{
	m_menu.DestroyMenu();	
	m_menu.CreatePopupMenu();
}

//

void ccMenuButton::addMenuItem(CString asText, UINT nIDNewItem )
{
	VERIFY( m_menu.AppendMenu(MF_STRING | MF_ENABLED, nIDNewItem, asText) );	
}

//

BOOL ccMenuButton::enableMenuItemCheck(int aiMenuItem, BOOL abEnable)
{
	DWORD dwFlags ;

	if (abEnable)
		dwFlags = MF_CHECKED;
		
	m_menu.CheckMenuItem(aiMenuItem, dwFlags );
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// Implementation
/////////////////////////////////////////////////////////////////////////////

int ccMenuButton::showMenu()
{
    // Vars and Assignment
    DWORD dwSelectionMade;

    // get the point where the menu is to be displayed.    
    CRect rect;
    GetWindowRect(rect);

    // show and track the menu
    dwSelectionMade = m_menu.TrackPopupMenu( (TPM_LEFTALIGN|TPM_LEFTBUTTON|TPM_NONOTIFY|TPM_RETURNCMD),
                                                   rect.right, rect.top, this
                                                );
    // The value of dwSelectionMade is the id of the command selected or 0 if no selection was made
	return dwSelectionMade;	
}

/////////////////////////////////////////////////////////////////////////////
// Overrides
/////////////////////////////////////////////////////////////////////////////

void ccMenuButton::PreSubclassWindow() 
{
	
	SetIcon(IDI_ARROW_RIGHT);
	DrawBorder(FALSE);
	
	CButtonST::PreSubclassWindow();
}
