// ==========================================================================
//                    Class Specification : ccMenuButton
// ==========================================================================
//////////////////////////////////////////////////////////////////////
// $File name   : /ccLib/dev/ccgLib/ccError.h: 
//
// $Author      : Daniel Lindh (Daniel.Lindh@home.se)
// $HomePage    : home.bip.net/CyberCow
// $ICQ         : 7983755
//
// Notice       : Copyright (c) CyberCow 1999
//                Knypplerskevagen 24
//                168 38 BROMMA
//                SWEDEN  
//                tel int + 46 (8) 26 45 95
//                
//                The copyright to the computer program(s) herein is the 
//				  property of CyberCow.The program(s) may be used and/or 
//				  copied only with the written permission of CyberCow or 
//				  in accordance with the terms and conditions stipulated 
//				  in the agreement/contract under which the program(s) 
//				  have been supplied. 
//
/////////////////////////////////////////////////////////////////////////////
///** $History$ *************************************************************
// *
// * $Date: 9/09/99 6:54p $
// * $Revision: 11 $
// * 
// * *****************  Version 1  *****************
// * User: Daniel Date: 9/09/99 6:54p
// * Source-Code Traced [ ]; Reviewd [ ] 
// * Created in $/ccLib/dev/ccgLib
// * Initial release.
// * 
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
// ** $Properties$ **********************************************************
// * [ ] Abstract class (does not have any objects)
// * [ ] Uses exceptions
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
/*
$Description : 

A Button Ctrl. When you press it you will get a floating menu at the right side.
The button will be flat button whith a arrow to the right

*/
/////////////////////////////////////////////////////////////////////////////

#ifndef __CCMENUBUTTON_H__
#define __CCMENUBUTTON_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ccMenuButton.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// ccMenuButton window
#include "codeguru\\BtnST.h"

class AFX_EXT_CLASS ccMenuButton : public CButtonST
{

// Properties
public:
	// Clear the floating menu.
	//
	void clearMenu();

	// Add a menu item and associate it to a command ID.
	//
	void addMenuItem(CString asText, UINT nIDNewItem);

	// Set or remove a check before a menu item.
	//
	BOOL enableMenuItemCheck(int aiMenuItem, BOOL abEnable);

private:
	CMenu m_menu;	

// Implementation
public:
	// Show the floating menu
	//
	int	 showMenu();


// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(ccMenuButton)
	public:	
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL	

	// Generated message map functions
protected:
	//{{AFX_MSG(ccMenuButton)			
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // __CCMENUBUTTON_H__
