// ccPropertySheet.cpp : implementation file
//

#include "stdafx.h"
#include "ccPropertySheet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// *** ccPropertySheet
/////////////////////////////////////////////////////////////////////////////

IMPLEMENT_DYNAMIC(ccPropertySheet, CPropertySheet)

ccPropertySheet::ccPropertySheet()
	:CPropertySheet()
{
}
ccPropertySheet::ccPropertySheet(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
}

ccPropertySheet::ccPropertySheet(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
}

ccPropertySheet::~ccPropertySheet()
{
}


BEGIN_MESSAGE_MAP(ccPropertySheet, CPropertySheet)
	//{{AFX_MSG_MAP(ccPropertySheet)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// *** Buttons
/////////////////////////////////////////////////////////////////////////////
void ccPropertySheet::enableButton( int nID, bool abEnable /*= true*/)
{
	CWnd* pWnd = GetDlgItem(nID);
	ASSERT_VALID(pWnd);
	if (pWnd)
	{
		if (abEnable)
			pWnd->ShowWindow(SW_SHOW);
		else
			pWnd->ShowWindow(SW_HIDE);
	}
}

//

void ccPropertySheet::autoArrangeStdButtons()
{
	CWnd* pWnd = GetDlgItem(ID_APPLY_NOW);
	
	if (pWnd && ::IsWindow(pWnd->m_hWnd))
	{
		// Get the last control in the tab order - (tab order is the same as creation order)
		pWnd = pWnd->GetWindow(GW_HWNDLAST);

		// Get the tab control
		CTabCtrl* pTabCtrl = GetTabControl();

		// Get the child identifier of the tab control
		int nTabControlID = ::GetWindowLong(pTabCtrl->m_hWnd, GWL_ID);

		// Child control identifier
		int nControlID = 0;

		// The window rect of the tab control.
		CRect rcTAB(0, 0, 0, 0);

		pTabCtrl->GetWindowRect(rcTAB);

		ScreenToClient(rcTAB);

		CRect rcTemp(0, 0, 0, 0);

		GetClientRect(rcTemp);

		int nLeft = rcTemp.right;
		int nSpacing = rcTemp.right - rcTAB.right;

		// do this bit while we have a control to do something with
		while(pWnd)
		{
			// Get the ID of the current child control
			nControlID = ::GetWindowLong(pWnd->m_hWnd, GWL_ID);
			
			// Do not make changes to the tab control!!
			if (nControlID != nTabControlID)
			{
				// do some stuff
				pWnd->GetWindowRect(rcTemp);

				ScreenToClient(rcTemp);

				// Is the child control visible? - Don't use IsWindowVisible as the parent
				// also has to be visible for that to return TRUE;
				BOOL bChildIsVisible = ((pWnd->GetStyle() & WS_VISIBLE) == WS_VISIBLE);

				// Make sure we are below the TAB control
				if ((rcTemp.top > rcTAB.bottom) && bChildIsVisible)
				{
					// Move each control
					nLeft -= nSpacing + rcTemp.Width();
					
					pWnd->MoveWindow(nLeft, rcTemp.top, rcTemp.Width(), rcTemp.Height());
				}
			}
				
			// Go back in the TAB order again
			pWnd = pWnd->GetWindow(GW_HWNDPREV);
		}
	}
}

