// ==========================================================================
//                    Class Specification : ccPropertySheet
// ==========================================================================
//////////////////////////////////////////////////////////////////////
// $File name   : /ccLib/dev/ccgLib/ccPropertySheet.h: 
//
// $Author      : Daniel Lindh (Daniel.Lindh@home.se)
// $HomePage    : home.bip.net/CyberCow
// $ICQ         : 7983755
//
// Notice       : Copyright (c) CyberCow AB 2000
//                Ekbacksvgen 28
//                168 69 BROMMA
//                SWEDEN  
//                tel int + 46 (8) 555 362 95
//                
//                The copyright to the computer program(s) herein is the 
//				  property of CyberCow.The program(s) may be used and/or 
//				  copied only with the written permission of CyberCow or 
//				  in accordance with the terms and conditions stipulated 
//				  in the agreement/contract under which the program(s) 
//				  have been supplied. 
//
/////////////////////////////////////////////////////////////////////////////
///** $History$ *************************************************************
// *
// * $Date: 2/16/00 11:44p $
// * $Revision: 11 $
// * 
// * *****************  Version 1  *****************
// * User: Daniel Date: /16/00 11:44p
// * Source-Code Traced [ ]; Reviewd [ ] 
// * Created in $/ccLib/dev/ccgLib
// * Initial release.
// * 
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
// ** $Properties$ **********************************************************
// * [ ] Abstract class (does not have any objects)
// * [ ] Uses exceptions
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
/*
$Description : 

Some extension to mfc class CPropertySheet.
*/
/////////////////////////////////////////////////////////////////////////////

#ifndef __CCPROPERTYSHEET_H__
#define __CCPROPERTYSHEET_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ccPropertySheet.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// ccPropertySheet
class AFX_EXT_CLASS ccPropertySheet : public CPropertySheet
{
	DECLARE_DYNAMIC(ccPropertySheet)

// *** Construction/Destruction
public:
	// Standard constructors
	//
	ccPropertySheet();
	ccPropertySheet(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	ccPropertySheet(LPCTSTR pszCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	virtual ~ccPropertySheet();

// *** Buttons
public:
	// Enable control below the tab control
	//
	void enableButton( int nID, bool abEnable = true);

	// Enable apply button below the tab control
	//
	void enableApplyButton( bool abEnable)						{ enableButton(ID_APPLY_NOW, abEnable);		}

	// Enable help button below the tab control
	//
	void enableHelpButton( bool abEnable)						{ enableButton(IDHELP, abEnable);			}

	// Automatically arrange visible controls below the tab control 
	//
	void autoArrangeStdButtons();


// *** Overrides
public:
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(ccPropertySheet)
	public:	
	//}}AFX_VIRTUAL

// *** Implementation
public:
	
		

// *** Generated message map functions
protected:
	//{{AFX_MSG(ccPropertySheet)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // __CCPROPERTYSHEET_H__
