// ==========================================================================
//                    Class Specification : ccString
// ==========================================================================
//////////////////////////////////////////////////////////////////////
// $File name   : /ccLib/dev/ccgLib/ccString.h: 
//
// $Author      : Daniel Lindh (Daniel.Lindh@home.se)
// $HomePage    : home.bip.net/CyberCow
// $ICQ         : 7983755
//
// Notice       : Copyright (c) CyberCow 1999
//                Knypplerskevagen 24
//                168 38 BROMMA
//                SWEDEN  
//                tel int + 46 (8) 26 45 95
//                
//                The copyright to the computer program(s) herein is the 
//				  property of CyberCow.The program(s) may be used and/or 
//				  copied only with the written permission of CyberCow or 
//				  in accordance with the terms and conditions stipulated 
//				  in the agreement/contract under which the program(s) 
//				  have been supplied. 
//
/////////////////////////////////////////////////////////////////////////////
///** $History$ *************************************************************
// *
// * $Date: 9/09/99 11:24a $
// * $Revision: 11 $
// * 
// * *****************  Version 1  *****************
// * User: Daniel Date: 9/09/99    Time: 11:24a
// * Source-Code Traced [ ]; Reviewd [ ] 
// * Created in $/ccLib/dev/ccgLib
// * Initial release.
// * 
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
// ** $Properties$ **********************************************************
// * [ ] Abstract class (does not have any objects)
// * [ ] Uses exceptions
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
/*
$Description : 

A simple CString derived class with some new methods for use with numeric types.
*/
/////////////////////////////////////////////////////////////////////////////

#ifndef __CCSTRING_H__
#define __CCSTRING_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
class ccTime;
class AFX_EXT_CLASS ccString : public CString  
{
// Construction
public:
	// Standard constructor
	//
	ccString();

	// Creates a ccString object with an integer value.
	//
	ccString(int aiNumber);
	ccString(UINT aiNumber);

	ccString(char c)					{ 	Format("%s", c);				};
	ccString(char *c)					{ 	Format("%s", c);				};
	ccString(const char *c)				{ 	Format("%s", c);				};

// Destruction
public:
	// Standard destructor
	virtual ~ccString();

// Input/Output
public:
	// Assign the an integer value to the ccString
	//
	CString& operator = (int aiNumber);	
	
	// The ccString object returns an integer value.
	//
	operator int();

// *** Operator <<
public:	
	ccString& operator << ( int n );	
	ccString& operator << ( char c );
	ccString& operator << ( char * c );
	ccString& operator << ( const char * c );
	ccString& operator << ( DWORD dw );
	ccString& operator << ( UINT n );
	ccString& operator << ( ccTime tm );
	ccString& operator << ( CString &c );
};

#endif // __CCSTRING_H__
