// ccTabCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "CODEPROJECT\\LBTabCtrl.h"
#include "ccTabCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ccTabCtrl

ccTabCtrl::ccTabCtrl() :
	m_currentDialog(NULL)
{
}

ccTabCtrl::~ccTabCtrl()
{
	removeAll();
}


BEGIN_MESSAGE_MAP(ccTabCtrl, CTabCtrl)
	//{{AFX_MSG_MAP(ccTabCtrl)
	ON_NOTIFY_REFLECT(TCN_SELCHANGE, OnSelchange)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ccTabCtrl message handlers

void ccTabCtrl::OnSelchange(NMHDR* pNMHDR, LRESULT* pResult) 
{
	if (m_currentDialog != NULL)
		m_currentDialog->ShowWindow( SW_HIDE );
	for(int i = 0; i < m_dialogs.GetSize();i++)
	{
		if ( i == GetCurSel() )
		{
			m_currentDialog = (CDialog*)m_dialogs[i];
			break;
		}
	}	

	if ( m_currentDialog != NULL )
	{
		resizeTabPage();
		m_currentDialog->ShowWindow( SW_SHOW );
	}
		
	*pResult = 0;
}

BOOL ccTabCtrl::InsertItem(int nItem, LPCTSTR lpszItem, CDialog *oDialog)
{
	BOOL liRetVal = CTabCtrl::InsertItem(nItem, lpszItem);
	if ( m_dialogs.GetSize() <= (nItem+1) )
		m_dialogs.SetSize( (nItem+1) );

	m_dialogs[ nItem ] = oDialog;

	if ( m_currentDialog == NULL )
	{
		m_currentDialog = oDialog;
		resizeTabPage();
		m_currentDialog->ShowWindow( SW_SHOW );
	}
	if ( m_currentDialog != NULL )
		m_currentDialog->SetFocus();

	return liRetVal;
}

void ccTabCtrl::resizeTabPage()
{	
	if ( m_currentDialog != NULL )
	{
		CRect lTabCtrlClientRect;		
		//m_tab.GetWindowRect( lTabCtrlClientRect );		
		GetClientRect( lTabCtrlClientRect );		
		AdjustRect(false, lTabCtrlClientRect );		

		
		m_currentDialog->SetWindowPos(NULL,lTabCtrlClientRect.left,lTabCtrlClientRect.top,lTabCtrlClientRect.Width(),lTabCtrlClientRect.Height(), SWP_NOZORDER );
	}
}

void ccTabCtrl::OnSize(UINT nType, int cx, int cy) 
{
	CTabCtrl::OnSize(nType, cx, cy);
	
	resizeTabPage();	
}

void ccTabCtrl::removeAll()
{
	while(m_dialogs.GetSize())
	{
		((CDialog*)m_dialogs[0])->DestroyWindow();
		delete ((CDialog*)m_dialogs[0]);
		m_dialogs.RemoveAt( 0 );
	}
}
