// ==========================================================================
//                    Class Specification : ccTime
// ==========================================================================
//////////////////////////////////////////////////////////////////////
// $File name   : /ccLib/dev/ccgLib/ccTime.h: 
//
// $Author      : Daniel Lindh (Daniel.Lindh@home.se)
// $HomePage    : home.bip.net/CyberCow
// $ICQ         : 7983755
//
// Notice       : Copyright (c) CyberCow 1999
//                Knypplerskevagen 24
//                168 38 BROMMA
//                SWEDEN  
//                tel int + 46 (8) 26 45 95
//                
//                The copyright to the computer program(s) herein is the 
//				  property of CyberCow.The program(s) may be used and/or 
//				  copied only with the written permission of CyberCow or 
//				  in accordance with the terms and conditions stipulated 
//				  in the agreement/contract under which the program(s) 
//				  have been supplied. 
//
/////////////////////////////////////////////////////////////////////////////
///** $History$ *************************************************************
// *
// * $Date: 9/15/99 23:08 $
// * $Revision: 1 $
// * 
// * *****************  Version 1  *****************
// * User: Daniel Date: 9/15/99 23:08
// * Source-Code Traced [ ]; Reviewd [ ] 
// * Created in $/ccLib/dev/ccgLib
// * Initial release.
// * 
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
// ** $Properties$ **********************************************************
// * [ ] Abstract class (does not have any objects)
// * [ ] Uses exceptions
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
/*
$Description : 

This is a year 2038 safe time class derivied from the dito safe class CGoodTime. 
This class has an exctended interface, which handles assigning date and time
formated strings.

*/
/////////////////////////////////////////////////////////////////////////////

#ifndef __CCTIME_H__
#define __CCTIME_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CodeGuru\GoodTime.h"

class AFX_EXT_CLASS ccTime : public CGoodTime  
{
// *** Construction
public:
	// Default constructor
	//
	ccTime();

	// Set the ccTime object to date taken from a string
	// with the format "yyyy-mm-dd hh:mm:ss".
	//
	ccTime( CString lsDataBaseDateTime );
	

// *** Input/Output
public:
	// Handling input/output with string format "yyyy-mm-dd"
	//
	void	setDate( int aiYear, int aiMonth, int aiDay );
	void	setDate( CString asDate );
	CString getDate();
	
	// Handling input/output with string format "hh:mm:ss"
	//
	void	setTime( int aiHour, int aiMin, int aiSec );
	void	setTime( CString asTime );
	CString getTime();

	// Handling input/output with string format "yyyy-mm-dd hh:mm:ss"
	//
	void    setDateTime(int nYear, int nMonth, int nDay, int nHour, int nMin, int nSec);
	void    setDateTime( CString asDateTime );
	CString getDateTime();

};
#endif // __CCTIME_H__
