// ==========================================================================
//                    Class Specification : ccTraceFile
// ==========================================================================
//////////////////////////////////////////////////////////////////////
// $File name   : /ccLib/dev/ccgLib/ccTraceFile.h: 
//
// $Author      : Daniel Lindh (Daniel.Lindh@home.se)
// $HomePage    : home.bip.net/CyberCow
// $ICQ         : 7983755
//
// Notice       : Copyright (c) CyberCow 1999
//                Knypplerskevagen 24
//                168 38 BROMMA
//                SWEDEN  
//                tel int + 46 (8) 26 45 95
//                
//                The copyright to the computer program(s) herein is the 
//				  property of CyberCow.The program(s) may be used and/or 
//				  copied only with the written permission of CyberCow or 
//				  in accordance with the terms and conditions stipulated 
//				  in the agreement/contract under which the program(s) 
//				  have been supplied. 
//
/////////////////////////////////////////////////////////////////////////////
///** $History$ *************************************************************
// *
// * $Date: 6/23/99 12:04a $
// * $Revision: 11 $
// * 
// * *****************  Version 1  *****************
// * User: Daniel Date: 6/23/99    Time: 12:04a
// * Source-Code Traced [X]; Reviewd [X] 
// * Created in $/ccLib/dev/ccgLib
// * Initial release.
// * 
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
// ** $Properties$ **********************************************************
// * [ ] Abstract class (does not have any objects)
// * [ ] Uses exceptions
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
/*
$Description : 

A ccTraceFile object handles text-message logging to a file. This can 
be used for debugging, error logging, script logging, session logging etc.

*/
/////////////////////////////////////////////////////////////////////////////

#if !defined(_CCTRACEFILE_H__)
#define _CCTRACEFILE_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class AFX_EXT_CLASS ccTraceFile : public CStdioFile  
{
// *** Data Members
private:
	CString m_traceFile;				// The name of the log file.
	bool	m_traceing;					// True if the logging is enabled.
	int		m_logFileSize;				// The size of the log file in kilo bytes.

// *** Construction
public:			
	// Default Constructor 
    // 
	ccTraceFile();

	// Turn on and of the file logging.
	//
	E_ccErrRet enableLogging( BOOL abEnable = TRUE, BOOL abAppend = FALSE );

// *** Destruction
public:
	// Virtual destructor
	//
	virtual ~ccTraceFile();

// *** Properties
public:
	// Set the name of the tracefile.
	//
	void	setFileName( CString asFileName );

	// Opening a save as dialog, from which the user can 
	// select the trace file name.
	//
	void	browseTraceFile();

	// Get the name of the tracefile.
	//
	CString getFileName();

	// The size in kbytes the log file can have. When it reaches 
	// this size it will dispaly a warning message 
	//
	void	setLogSize( int aiLogSize ); 

	//  The size in kbytes the log file can have. 
	//
	int		getLogSize( );

// *** Input/Output
public:
	// Adds a message to the tracefile. 
	//
	void addMessage( CString asMessage ); 

	// View the information in the tracefile from notepad.
	//
	void view();

	// Clear the trace file.
	//
	void clear();

// *** Status
public:
	// Check if the trace has been started.
	//
	BOOL isTraceing( );
};

#endif // !defined(_CCTRACEFILE_H__)
