//////////////////////////////////////////////////////////////////////
// $File name   : ccTreeCtrl.cpp
//
// $Author      : Daniel Lindh (Daniel.Lindh@home.se)
// Notice       : Copyright (c) CyberCow AB 2000
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ccTreeCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// *** Construction/Destruction
/////////////////////////////////////////////////////////////////////////////

ccTreeCtrl::ccTreeCtrl()
{
}

//

ccTreeCtrl::~ccTreeCtrl()
{
}

/////////////////////////////////////////////////////////////////////////////
// *** Overrides
/////////////////////////////////////////////////////////////////////////////

BOOL ccTreeCtrl::PreTranslateMessage(MSG* pMsg) 
{
	// If edit control is visible in tree view control, sending a
	// WM_KEYDOWN message to the edit control will dismiss the edit
	// control.  When ENTER key was sent to the edit control, the parent
	// window of the tree view control is responsible for updating the
	// item's label in TVN_ENDLABELEDIT notification code.
	if ( pMsg->message == WM_KEYDOWN )
	{		
		CEdit* edit = GetEditControl();
		if (edit)
		{
			if( GetKeyState( VK_CONTROL ) && pMsg->wParam == VK_C )
			{
				edit->Copy();
				return TRUE;
			}
			if( GetKeyState( VK_CONTROL ) && pMsg->wParam == VK_V )
			{
				edit->Paste();
				return TRUE;
			}
			if( GetKeyState( VK_CONTROL ) && pMsg->wParam == VK_X )
			{
				edit->Cut();
				return TRUE;
			}
			if( GetKeyState( VK_CONTROL ) && pMsg->wParam == VK_Z )
			{
				edit->Undo();
				return TRUE;
			}
			if( pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE || pMsg->wParam == VK_CONTROL || pMsg->wParam == VK_INSERT || pMsg->wParam == VK_SHIFT ||pMsg->wParam == VK_DELETE)
			{
				edit->SendMessage(WM_KEYDOWN, pMsg->wParam, pMsg->lParam);
				return TRUE;
			}
		}
	}
		
	return CCJTreeCtrl::PreTranslateMessage(pMsg);
}

/////////////////////////////////////////////////////////////////////////////
// *** Generated message map functions
/////////////////////////////////////////////////////////////////////////////
IMPLEMENT_DYNAMIC(ccTreeCtrl, CCJTreeCtrl)

BEGIN_MESSAGE_MAP(ccTreeCtrl, CCJTreeCtrl)
	//{{AFX_MSG_MAP(ccTreeCtrl)
	ON_WM_KEYDOWN()
	ON_WM_RBUTTONDOWN()	
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void ccTreeCtrl::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	switch( nChar )
	{
	case VK_F2:
		{
			// To Use F2 as hot Key to get EditCtrl on the TreeView it must have 
			// the Style LVS_EDITLABELS			
			if ( GetStyle() & TVS_EDITLABELS )
			{			
				HTREEITEM lhCurrentItem = GetSelectedItem();
				if (lhCurrentItem != NULL)
				{			
					EditLabel( lhCurrentItem );
				}
				else
					CCJTreeCtrl::OnKeyDown( nChar, nRepCnt, nFlags );			
			}
			else
				CCJTreeCtrl::OnKeyDown( nChar, nRepCnt, nFlags );
		}
		break;
	case VK_DELETE:
		{
			HTREEITEM lhCurrentItem = GetSelectedItem();
			if (lhCurrentItem != NULL)
			{			
				DeleteItem( lhCurrentItem );				
			}
			else
				CCJTreeCtrl::OnKeyDown( nChar, nRepCnt, nFlags );
		}
		break;

	default:
		CCJTreeCtrl::OnKeyDown( nChar, nRepCnt, nFlags );
		break;
	}		
}

//

void ccTreeCtrl::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// Select with right click, as you do with a left click.
	HTREEITEM lhTreeItem = HitTest(point);
	if (lhTreeItem)
		SelectItem( lhTreeItem );	
	
	CTreeCtrl::OnRButtonDown(nFlags, point);
}

//

