// ==========================================================================
//                    Class Specification : ccTreeCtrl
// ==========================================================================
//////////////////////////////////////////////////////////////////////
// $File name   : /ccLib/dev/ccLib/ccgLib/ccTreeCtrl
//
// $Author      : Daniel Lindh (Daniel.Lindh@home.se)
// $HomePage    : home.bip.net/CyberCow
// $ICQ         : 7983755
//
// Notice       : Copyright (c) CyberCow AB 2000
//                Ekbacksv. 28
//                168 69 BROMMA
//                SWEDEN  
//                tel int + 46 (8) 555 362 95
//                
//                The copyright to the computer program(s) herein is the 
//				  property of CyberCow.The program(s) may be used and/or 
//				  copied only with the written permission of CyberCow or 
//				  in accordance with the terms and conditions stipulated 
//				  in the agreement/contract under which the program(s) 
//				  have been supplied. 
//
/////////////////////////////////////////////////////////////////////////////
///** $History$ *************************************************************
// *
// * $Date: 3/21/2000 16:42 $
// * $Revision: 1 $
// * 
// * *****************  Version 1  *****************
// * User: Daniel Date: 3/21/2000 16:42 $
// * Source-Code Traced [X]; Reviewd [ ] 
// * Created in $/ccLib/dev/ccgLib
// * Initial release.
// * 
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
// ** $Properties$ **********************************************************
// * [ ] Abstract class (does not have any objects)
// * [ ] Uses exceptions
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
/*
$Description : 
	A TreeCtrl class how can handle F2 renaming and "del" deleting.
	And "SelectItem" when right clicked.

*/
/////////////////////////////////////////////////////////////////////////////
#ifndef __CCTREECTRL_H__
#define __CCTREECTRL_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class AFX_EXT_CLASS ccTreeCtrl : public CCJTreeCtrl
{
// *** Construction/Destruction
public:
	// Default constructor
	//	
	ccTreeCtrl();
	DECLARE_DYNAMIC(ccTreeCtrl)

	// Default destructor
	//
	virtual ~ccTreeCtrl();

// *** Operations
public:
	// Called by OnKeyDown etc. Need to be virtual so a
	// derivied class can stop the deleting if needed	
	//
	virtual BOOL DeleteItem( HTREEITEM hItem )		{ return CCJTreeCtrl::DeleteItem(hItem);	};

// *** Overrides
public:
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(ccTreeCtrl)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL

// *** Generated message map functions
protected:
	//{{AFX_MSG(ccTreeCtrl)
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
public:
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // __CCTREECTRL_H__
