//////////////////////////////////////////////////////////////////////
// $File name   : ccgLib.cpp: 
//
// $Author      : Daniel Lindh (Daniel.Lindh@home.se)
// Notice       : Copyright (c) CyberCow 1999
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <afxdllx.h>
#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


static AFX_EXTENSION_MODULE CcgLibDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("CCGLIB10d.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(CcgLibDLL, hInstance))
			return 0;

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		new CDynLinkLibrary(CcgLibDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("CCGLIB.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(CcgLibDLL);
	}
	return 1;   // ok
}

//

CString getSaveAsFile( CString asFileName, CString asFileNameExtension )
{	
	CFileDialog oFileDialog( FALSE, asFileNameExtension, asFileName, OFN_CREATEPROMPT 
						    | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST );
	
	if ( oFileDialog.DoModal() == IDOK )	
		return oFileDialog.GetPathName( );	
	else
		return "-1";
}

//

E_ccErrRet fileExist( CString lsFileName )
{
	CFileFind finder;   
	BOOL bWorking = finder.FindFile( lsFileName );
	if (bWorking)   
	{
		return CCFOUND;
	}

	return CCFAILED;
}

//
 
int AfxMessageBoxF( UINT nType, PSTR sz,... )
{ 
    char ach[512];
    va_list args; 
    va_start(args, sz); 
    wvsprintf (ach, sz, args); /* Format the string */
    int retval = AfxMessageBox (ach, nType == 0 ? MB_OK|MB_ICONEXCLAMATION : nType);    
    return retval;	
}

//

void ccMBox( int nIDText, int nIDCaption)
{
	CString strText; strText.LoadString( nIDText );
	CString strCaption; strCaption.LoadString( nIDCaption );
	MessageBox(NULL, strText, strCaption, NULL );
}

//

void ccDelay( int aiTime )
{
	for(int i =0; i < aiTime;i++)
	{
		CString moo;
		moo.Format("%u", i);
	}
}

//

E_ccErrRet surfTo(CString asWebPage, CWnd * pParentWnd, E_BROWSER_TYPE aBrowserType/* = CC_DEFAULT */ )
{
	NEEDVALUE( pParentWnd );
	E_ccErrRet oRetValue;
	oRetValue = CCFAILED;

	if ( ! asWebPage.IsEmpty() )
	{
		//Be sure http:// is in the beginning of the web address.
		asWebPage.MakeLower();
		asWebPage.Replace("http://","");
		asWebPage.Insert(0,"http://");
				
		CString lsFile;
		CString lsParameters;

		//Select browser to browse the web page with.
		switch ( aBrowserType ) 
		{			
			case CCB_EXPLORER:				
				lsFile = "iExplore.exe";
				lsParameters = asWebPage;
				break;
			case CCB_NETSCAPE:
				//TODO
				MessageBox(NULL, "Netscape Isnot tested yet","",MB_OK);				
				lsFile = "Netscape.exe";
				lsParameters = asWebPage;
				break;
			case CCB_MOSAIC:
				//TODO
				MessageBox(NULL, "Mosaic Isnot tested yet","",MB_OK);				
				lsFile = "Mosaic.exe";
				lsParameters = asWebPage;
				break;
			case CCB_OPERA:
				//TODO
				MessageBox(NULL, "Opera Isnot tested yet","",MB_OK);				
				lsFile = "Opera.exe";
				lsParameters = asWebPage;
				break;

			//Use the default browser
			case CCB_DEFAULT :
			default:
				lsFile = asWebPage;
				lsParameters = "";
				break;
		}			
		
		oRetValue = CCSUCCEDED;

		while ( (int)ShellExecute( pParentWnd->m_hWnd, "open", lsFile, lsParameters, NULL, SW_SHOWDEFAULT ) <= 32)	
		{
			if ( AfxMessageBox( IDS_ERR_CANT_OPEN_BROWSER, MB_RETRYCANCEL ) != IDRETRY )
			{
				oRetValue = CCFAILED;
				break;
			}
		}
		
		return oRetValue;
	}
	else
		return oRetValue;
}

//

E_ccErrRet mailTo(CString asMailTo, CWnd * pParentWnd, E_MAILCLIENT_TYPE  aMailClientType/* = CC_DEFAULT */ )
{
	E_ccErrRet oRetValue;
	oRetValue = CCFAILED;

	if ( ! asMailTo.IsEmpty() )
	{
		//Be sure http:// is in the beginning of the web address.
		asMailTo.MakeLower();
		asMailTo.Replace("mailto:","");
		asMailTo.Insert(0,"mailto:");
				
		CString lsFile;
		CString lsParameters;

		//Select mailclient to mail with.
		switch ( aMailClientType ) 
		{			
			case CCMC_OUTLOOK:
				lsFile = "OutLook.exe";
				lsParameters = "/c ipm.note";
				break;

			//Use the default mail client
			case CCMC_DEFAULT :
			default:
				lsFile = asMailTo;
				lsParameters = "";
				break;
		}
		
		oRetValue = CCSUCCEDED;

		while ( (int)ShellExecute( pParentWnd->m_hWnd, "open", lsFile, lsParameters, NULL, SW_SHOWDEFAULT ) <= 32)	
		{
			if ( AfxMessageBox( IDS_ERR_CANT_OPEN_MAIL_READER, MB_RETRYCANCEL ) != IDRETRY )
			{
				oRetValue = CCFAILED;
				break;
			}
		}
		
		return oRetValue;
	}
	else
		return oRetValue;
}

