//////////////////////////////////////////////////////////////////////
// $File name   : /ccLib/dev/ccgLib/ccgLib.h: 
//
// $Author      : Daniel Lindh (Daniel.Lindh@home.se)
// $HomePage    : home.bip.net/CyberCow
// $ICQ         : 7983755
//
// Notice       : Copyright (c) CyberCow 1999
//                Knypplerskevagen 24
//                168 38 BROMMA
//                SWEDEN  
//                tel int + 46 (8) 26 45 95
//                
//                The copyright to the computer program(s) herein is the 
//				  property of CyberCow.The program(s) may be used and/or 
//				  copied only with the written permission of CyberCow or 
//				  in accordance with the terms and conditions stipulated 
//				  in the agreement/contract under which the program(s) 
//				  have been supplied. 
//
/////////////////////////////////////////////////////////////////////////////
///** $History$ *************************************************************
// *
// * $Date: 9/02/99 3:53 $
// * $Revision: 11 $
// * 
// * *****************  Version 1  *****************
// * User: Daniel Date: 9/02/99 3:53 
// * Source-Code Traced [ ]; Reviewd [ ] 
// * Created in $/ccLib/dev/ccgLib
// * Initial release.
// * 
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
// ** $Properties$ **********************************************************
// * [ ] Abstract class (does not have any objects)
// * [ ] Uses exceptions
// **************************************************************************
/////////////////////////////////////////////////////////////////////////////
/*
$Description : 

This file includes global constants, variables and functions in the ccgLib.

*/
/////////////////////////////////////////////////////////////////////////////

#ifndef __CCGLIB_H__
#define __CCGLIB_H__

#define CRLF "\x0d\x0a"			// New Line

#define ON  TRUE				// Synonym to TRUE
#define OFF FALSE				// Synonym to FALSE

#define VK_C		67			// Virtual Key for C
#define VK_V		86			// Virtual Key for V
#define VK_X		88			// Virtual Key for X
#define VK_Z		90			// Virtual Key for Z

// Used as a return value by functions. Give the caller a better ide 
// what has happend in the function. If it totally failed or succeded etc.

enum E_ccErrRet
{
	CCFATALERROR = -1,
	CCERROR		 = 0,
	CCFAILED     = 0,
	CCNOTFOUND   = 0,
	CCNOERROR    = 1,
	CCSUCCEDED   = 1,
	CCFOUND      = 1
};
//Show a "save as" dialog window, and lets the user to select a directory.
//
__declspec(dllexport)  CString getSaveAsFile( CString asFileName, CString asFileNameExtension);

//Check if the specified file exist.
//
__declspec(dllexport)  E_ccErrRet fileExist( CString lsFileName );

// This small utility funtion will simply put up a userdefined 
// message box with a string formatted like printf().
//
__declspec(dllexport)  int AfxMessageBoxF(UINT nType, PSTR sz,...);

// Show a messagebox based on String resources.
//
void AFX_EXT_CLASS ccMBox( int nIDText, int nIDCaption);

// Delay the program .
//
__declspec(dllexport)  void ccDelay(int aiTime);

// Diffrent web browser types.
//
enum E_BROWSER_TYPE
{
	CCB_DEFAULT  = 0,
	CCB_EXPLORER,
	CCB_NETSCAPE,
	CCB_MOSAIC,
	CCB_OPERA
};

// Diffrent mail reader types.
//
enum E_MAILCLIENT_TYPE
{
	CCMC_DEFAULT  = 0,
	CCMC_OUTLOOK,
};

// Open a specific web browser with a specific URL.
//
__declspec(dllexport)  E_ccErrRet surfTo(CString asWebPage, CWnd * pParentWnd, E_BROWSER_TYPE  aBrowserType = CCB_DEFAULT );

// Open a specific mail reader with a specific e-mail adress.
//
__declspec(dllexport)  E_ccErrRet mailTo(CString asMailTo , CWnd * pParentWnd, E_MAILCLIENT_TYPE  aMailClientType = CCMC_DEFAULT  );

// Check if SHIFT is pressed. 
//
#define isSHIFTPressed() ( (GetKeyState(VK_SHIFT) & (1 << (sizeof(SHORT)*8-1))) != 0   )

// Check if CTRL is pressed.
//
#define isCTRLPressed()  ( (GetKeyState(VK_CONTROL) & (1 << (sizeof(SHORT)*8-1))) != 0 )

#endif // __CCGLIB_H__